/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "osm_qos_parser_y.y"

/*
 * Copyright (c) 2004-2009 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2002-2008 Mellanox Technologies LTD. All rights reserved.
 * Copyright (c) 1996-2003 Intel Corporation. All rights reserved.
 * Copyright (c) 2008 HNR Consulting. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

/*
 * Abstract:
 *    Grammar of OSM QoS parser.
 *
 * Environment:
 *    Linux User Mode
 *
 * Author:
 *    Yevgeny Kliteynik, Mellanox
 */

#include <stdio.h>
#include <assert.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_QOS_PARSER_Y_Y
#include <opensm/osm_opensm.h>
#include <opensm/osm_qos_policy.h>

#define OSM_QOS_POLICY_MAX_LINE_LEN         1024*10
#define OSM_QOS_POLICY_SL2VL_TABLE_LEN      IB_MAX_NUM_VLS
#define OSM_QOS_POLICY_MAX_VL_NUM           IB_MAX_NUM_VLS
#define OSM_QOS_POLICY_MAX_RATE             IB_MAX_RATE
#define OSM_QOS_POLICY_MIN_RATE             IB_MIN_RATE
#define OSM_QOS_POLICY_MAX_MTU              IB_MAX_MTU
#define OSM_QOS_POLICY_MIN_MTU              IB_MIN_MTU

typedef struct tmp_parser_struct_t_ {
    char       str[OSM_QOS_POLICY_MAX_LINE_LEN];
    uint64_t   num_pair[2];
    cl_list_t  str_list;
    cl_list_t  num_list;
    cl_list_t  num_pair_list;
} tmp_parser_struct_t;

static void __parser_tmp_struct_init();
static void __parser_tmp_struct_reset();
static void __parser_tmp_struct_destroy();

static char * __parser_strip_white(char * str);

static void __parser_str2uint64(uint64_t * p_val, char * str);

static void __parser_port_group_start();
static int __parser_port_group_end();

static void __parser_sl2vl_scope_start();
static int __parser_sl2vl_scope_end();

static void __parser_vlarb_scope_start();
static int __parser_vlarb_scope_end();

static void __parser_qos_level_start();
static int __parser_qos_level_end();

static void __parser_match_rule_start();
static int __parser_match_rule_end();

static void __parser_ulp_match_rule_start();
static int __parser_ulp_match_rule_end();

static void __pkey_rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len);

static void __rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len);

static void __merge_rangearr(
    uint64_t  **   range_arr_1,
    unsigned       range_len_1,
    uint64_t  **   range_arr_2,
    unsigned       range_len_2,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len );

static void __parser_add_port_to_port_map(
    cl_qmap_t   * p_map,
    osm_physp_t * p_physp);

static void __parser_add_guid_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len);

static void __parser_add_pkey_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len);

static void __parser_add_partition_list_to_port_map(
    cl_qmap_t  * p_map,
    cl_list_t  * p_list);

static void __parser_add_map_to_port_map(
    cl_qmap_t * p_dmap,
    cl_map_t  * p_smap);

static int __validate_pkeys(
    uint64_t ** range_arr,
    unsigned    range_len,
    boolean_t   is_ipoib);

static void __setup_simple_qos_levels();
static void __clear_simple_qos_levels();
static void __setup_ulp_match_rules();
static void __process_ulp_match_rules();
static void yyerror(const char *format, ...);

extern char * yytext;
extern int yylex (void);
extern FILE * yyin;
extern int errno;
extern void yyrestart(FILE *input_file);
int yyparse();

#define RESET_BUFFER  __parser_tmp_struct_reset()

tmp_parser_struct_t tmp_parser_struct;

int column_num;
int line_num;

osm_qos_policy_t       * p_qos_policy = NULL;
osm_qos_port_group_t   * p_current_port_group = NULL;
osm_qos_sl2vl_scope_t  * p_current_sl2vl_scope = NULL;
osm_qos_vlarb_scope_t  * p_current_vlarb_scope = NULL;
osm_qos_level_t        * p_current_qos_level = NULL;
osm_qos_match_rule_t   * p_current_qos_match_rule = NULL;
osm_log_t              * p_qos_parser_osm_log;

/* 16 Simple QoS Levels - one for each SL */
static osm_qos_level_t osm_qos_policy_simple_qos_levels[16];

/* Default Simple QoS Level */
osm_qos_level_t __default_simple_qos_level;

/*
 * List of match rules that will be generated by the
 * qos-ulp section. These rules are concatenated to
 * the end of the usual matching rules list at the
 * end of parsing.
 */
static cl_list_t __ulp_match_rules;

/***************************************************/


#line 264 "osm_qos_parser_y.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_OSM_QOS_PARSER_Y_H_INCLUDED
# define YY_YY_OSM_QOS_PARSER_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TK_NUMBER = 258,               /* TK_NUMBER  */
    TK_DASH = 259,                 /* TK_DASH  */
    TK_DOTDOT = 260,               /* TK_DOTDOT  */
    TK_COMMA = 261,                /* TK_COMMA  */
    TK_ASTERISK = 262,             /* TK_ASTERISK  */
    TK_TEXT = 263,                 /* TK_TEXT  */
    TK_QOS_ULPS_START = 264,       /* TK_QOS_ULPS_START  */
    TK_QOS_ULPS_END = 265,         /* TK_QOS_ULPS_END  */
    TK_PORT_GROUPS_START = 266,    /* TK_PORT_GROUPS_START  */
    TK_PORT_GROUPS_END = 267,      /* TK_PORT_GROUPS_END  */
    TK_PORT_GROUP_START = 268,     /* TK_PORT_GROUP_START  */
    TK_PORT_GROUP_END = 269,       /* TK_PORT_GROUP_END  */
    TK_QOS_SETUP_START = 270,      /* TK_QOS_SETUP_START  */
    TK_QOS_SETUP_END = 271,        /* TK_QOS_SETUP_END  */
    TK_VLARB_TABLES_START = 272,   /* TK_VLARB_TABLES_START  */
    TK_VLARB_TABLES_END = 273,     /* TK_VLARB_TABLES_END  */
    TK_VLARB_SCOPE_START = 274,    /* TK_VLARB_SCOPE_START  */
    TK_VLARB_SCOPE_END = 275,      /* TK_VLARB_SCOPE_END  */
    TK_SL2VL_TABLES_START = 276,   /* TK_SL2VL_TABLES_START  */
    TK_SL2VL_TABLES_END = 277,     /* TK_SL2VL_TABLES_END  */
    TK_SL2VL_SCOPE_START = 278,    /* TK_SL2VL_SCOPE_START  */
    TK_SL2VL_SCOPE_END = 279,      /* TK_SL2VL_SCOPE_END  */
    TK_QOS_LEVELS_START = 280,     /* TK_QOS_LEVELS_START  */
    TK_QOS_LEVELS_END = 281,       /* TK_QOS_LEVELS_END  */
    TK_QOS_LEVEL_START = 282,      /* TK_QOS_LEVEL_START  */
    TK_QOS_LEVEL_END = 283,        /* TK_QOS_LEVEL_END  */
    TK_QOS_MATCH_RULES_START = 284, /* TK_QOS_MATCH_RULES_START  */
    TK_QOS_MATCH_RULES_END = 285,  /* TK_QOS_MATCH_RULES_END  */
    TK_QOS_MATCH_RULE_START = 286, /* TK_QOS_MATCH_RULE_START  */
    TK_QOS_MATCH_RULE_END = 287,   /* TK_QOS_MATCH_RULE_END  */
    TK_NAME = 288,                 /* TK_NAME  */
    TK_USE = 289,                  /* TK_USE  */
    TK_PORT_GUID = 290,            /* TK_PORT_GUID  */
    TK_PORT_NAME = 291,            /* TK_PORT_NAME  */
    TK_PARTITION = 292,            /* TK_PARTITION  */
    TK_NODE_TYPE = 293,            /* TK_NODE_TYPE  */
    TK_GROUP = 294,                /* TK_GROUP  */
    TK_ACROSS = 295,               /* TK_ACROSS  */
    TK_VLARB_HIGH = 296,           /* TK_VLARB_HIGH  */
    TK_VLARB_LOW = 297,            /* TK_VLARB_LOW  */
    TK_VLARB_HIGH_LIMIT = 298,     /* TK_VLARB_HIGH_LIMIT  */
    TK_TO = 299,                   /* TK_TO  */
    TK_FROM = 300,                 /* TK_FROM  */
    TK_ACROSS_TO = 301,            /* TK_ACROSS_TO  */
    TK_ACROSS_FROM = 302,          /* TK_ACROSS_FROM  */
    TK_SL2VL_TABLE = 303,          /* TK_SL2VL_TABLE  */
    TK_SL = 304,                   /* TK_SL  */
    TK_MTU_LIMIT = 305,            /* TK_MTU_LIMIT  */
    TK_RATE_LIMIT = 306,           /* TK_RATE_LIMIT  */
    TK_PACKET_LIFE = 307,          /* TK_PACKET_LIFE  */
    TK_PATH_BITS = 308,            /* TK_PATH_BITS  */
    TK_QOS_CLASS = 309,            /* TK_QOS_CLASS  */
    TK_SOURCE = 310,               /* TK_SOURCE  */
    TK_DESTINATION = 311,          /* TK_DESTINATION  */
    TK_SERVICE_ID = 312,           /* TK_SERVICE_ID  */
    TK_QOS_LEVEL_NAME = 313,       /* TK_QOS_LEVEL_NAME  */
    TK_PKEY = 314,                 /* TK_PKEY  */
    TK_NODE_TYPE_ROUTER = 315,     /* TK_NODE_TYPE_ROUTER  */
    TK_NODE_TYPE_CA = 316,         /* TK_NODE_TYPE_CA  */
    TK_NODE_TYPE_SWITCH = 317,     /* TK_NODE_TYPE_SWITCH  */
    TK_NODE_TYPE_SELF = 318,       /* TK_NODE_TYPE_SELF  */
    TK_NODE_TYPE_ALL = 319,        /* TK_NODE_TYPE_ALL  */
    TK_ULP_DEFAULT = 320,          /* TK_ULP_DEFAULT  */
    TK_ULP_ANY_SERVICE_ID = 321,   /* TK_ULP_ANY_SERVICE_ID  */
    TK_ULP_ANY_PKEY = 322,         /* TK_ULP_ANY_PKEY  */
    TK_ULP_ANY_TARGET_PORT_GUID = 323, /* TK_ULP_ANY_TARGET_PORT_GUID  */
    TK_ULP_ANY_SOURCE_PORT_GUID = 324, /* TK_ULP_ANY_SOURCE_PORT_GUID  */
    TK_ULP_ANY_SOURCE_TARGET_PORT_GUID = 325, /* TK_ULP_ANY_SOURCE_TARGET_PORT_GUID  */
    TK_ULP_SDP_DEFAULT = 326,      /* TK_ULP_SDP_DEFAULT  */
    TK_ULP_SDP_PORT = 327,         /* TK_ULP_SDP_PORT  */
    TK_ULP_RDS_DEFAULT = 328,      /* TK_ULP_RDS_DEFAULT  */
    TK_ULP_RDS_PORT = 329,         /* TK_ULP_RDS_PORT  */
    TK_ULP_ISER_DEFAULT = 330,     /* TK_ULP_ISER_DEFAULT  */
    TK_ULP_ISER_PORT = 331,        /* TK_ULP_ISER_PORT  */
    TK_ULP_SRP_GUID = 332,         /* TK_ULP_SRP_GUID  */
    TK_ULP_IPOIB_DEFAULT = 333,    /* TK_ULP_IPOIB_DEFAULT  */
    TK_ULP_IPOIB_PKEY = 334        /* TK_ULP_IPOIB_PKEY  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define TK_NUMBER 258
#define TK_DASH 259
#define TK_DOTDOT 260
#define TK_COMMA 261
#define TK_ASTERISK 262
#define TK_TEXT 263
#define TK_QOS_ULPS_START 264
#define TK_QOS_ULPS_END 265
#define TK_PORT_GROUPS_START 266
#define TK_PORT_GROUPS_END 267
#define TK_PORT_GROUP_START 268
#define TK_PORT_GROUP_END 269
#define TK_QOS_SETUP_START 270
#define TK_QOS_SETUP_END 271
#define TK_VLARB_TABLES_START 272
#define TK_VLARB_TABLES_END 273
#define TK_VLARB_SCOPE_START 274
#define TK_VLARB_SCOPE_END 275
#define TK_SL2VL_TABLES_START 276
#define TK_SL2VL_TABLES_END 277
#define TK_SL2VL_SCOPE_START 278
#define TK_SL2VL_SCOPE_END 279
#define TK_QOS_LEVELS_START 280
#define TK_QOS_LEVELS_END 281
#define TK_QOS_LEVEL_START 282
#define TK_QOS_LEVEL_END 283
#define TK_QOS_MATCH_RULES_START 284
#define TK_QOS_MATCH_RULES_END 285
#define TK_QOS_MATCH_RULE_START 286
#define TK_QOS_MATCH_RULE_END 287
#define TK_NAME 288
#define TK_USE 289
#define TK_PORT_GUID 290
#define TK_PORT_NAME 291
#define TK_PARTITION 292
#define TK_NODE_TYPE 293
#define TK_GROUP 294
#define TK_ACROSS 295
#define TK_VLARB_HIGH 296
#define TK_VLARB_LOW 297
#define TK_VLARB_HIGH_LIMIT 298
#define TK_TO 299
#define TK_FROM 300
#define TK_ACROSS_TO 301
#define TK_ACROSS_FROM 302
#define TK_SL2VL_TABLE 303
#define TK_SL 304
#define TK_MTU_LIMIT 305
#define TK_RATE_LIMIT 306
#define TK_PACKET_LIFE 307
#define TK_PATH_BITS 308
#define TK_QOS_CLASS 309
#define TK_SOURCE 310
#define TK_DESTINATION 311
#define TK_SERVICE_ID 312
#define TK_QOS_LEVEL_NAME 313
#define TK_PKEY 314
#define TK_NODE_TYPE_ROUTER 315
#define TK_NODE_TYPE_CA 316
#define TK_NODE_TYPE_SWITCH 317
#define TK_NODE_TYPE_SELF 318
#define TK_NODE_TYPE_ALL 319
#define TK_ULP_DEFAULT 320
#define TK_ULP_ANY_SERVICE_ID 321
#define TK_ULP_ANY_PKEY 322
#define TK_ULP_ANY_TARGET_PORT_GUID 323
#define TK_ULP_ANY_SOURCE_PORT_GUID 324
#define TK_ULP_ANY_SOURCE_TARGET_PORT_GUID 325
#define TK_ULP_SDP_DEFAULT 326
#define TK_ULP_SDP_PORT 327
#define TK_ULP_RDS_DEFAULT 328
#define TK_ULP_RDS_PORT 329
#define TK_ULP_ISER_DEFAULT 330
#define TK_ULP_ISER_PORT 331
#define TK_ULP_SRP_GUID 332
#define TK_ULP_IPOIB_DEFAULT 333
#define TK_ULP_IPOIB_PKEY 334

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_OSM_QOS_PARSER_Y_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TK_NUMBER = 3,                  /* TK_NUMBER  */
  YYSYMBOL_TK_DASH = 4,                    /* TK_DASH  */
  YYSYMBOL_TK_DOTDOT = 5,                  /* TK_DOTDOT  */
  YYSYMBOL_TK_COMMA = 6,                   /* TK_COMMA  */
  YYSYMBOL_TK_ASTERISK = 7,                /* TK_ASTERISK  */
  YYSYMBOL_TK_TEXT = 8,                    /* TK_TEXT  */
  YYSYMBOL_TK_QOS_ULPS_START = 9,          /* TK_QOS_ULPS_START  */
  YYSYMBOL_TK_QOS_ULPS_END = 10,           /* TK_QOS_ULPS_END  */
  YYSYMBOL_TK_PORT_GROUPS_START = 11,      /* TK_PORT_GROUPS_START  */
  YYSYMBOL_TK_PORT_GROUPS_END = 12,        /* TK_PORT_GROUPS_END  */
  YYSYMBOL_TK_PORT_GROUP_START = 13,       /* TK_PORT_GROUP_START  */
  YYSYMBOL_TK_PORT_GROUP_END = 14,         /* TK_PORT_GROUP_END  */
  YYSYMBOL_TK_QOS_SETUP_START = 15,        /* TK_QOS_SETUP_START  */
  YYSYMBOL_TK_QOS_SETUP_END = 16,          /* TK_QOS_SETUP_END  */
  YYSYMBOL_TK_VLARB_TABLES_START = 17,     /* TK_VLARB_TABLES_START  */
  YYSYMBOL_TK_VLARB_TABLES_END = 18,       /* TK_VLARB_TABLES_END  */
  YYSYMBOL_TK_VLARB_SCOPE_START = 19,      /* TK_VLARB_SCOPE_START  */
  YYSYMBOL_TK_VLARB_SCOPE_END = 20,        /* TK_VLARB_SCOPE_END  */
  YYSYMBOL_TK_SL2VL_TABLES_START = 21,     /* TK_SL2VL_TABLES_START  */
  YYSYMBOL_TK_SL2VL_TABLES_END = 22,       /* TK_SL2VL_TABLES_END  */
  YYSYMBOL_TK_SL2VL_SCOPE_START = 23,      /* TK_SL2VL_SCOPE_START  */
  YYSYMBOL_TK_SL2VL_SCOPE_END = 24,        /* TK_SL2VL_SCOPE_END  */
  YYSYMBOL_TK_QOS_LEVELS_START = 25,       /* TK_QOS_LEVELS_START  */
  YYSYMBOL_TK_QOS_LEVELS_END = 26,         /* TK_QOS_LEVELS_END  */
  YYSYMBOL_TK_QOS_LEVEL_START = 27,        /* TK_QOS_LEVEL_START  */
  YYSYMBOL_TK_QOS_LEVEL_END = 28,          /* TK_QOS_LEVEL_END  */
  YYSYMBOL_TK_QOS_MATCH_RULES_START = 29,  /* TK_QOS_MATCH_RULES_START  */
  YYSYMBOL_TK_QOS_MATCH_RULES_END = 30,    /* TK_QOS_MATCH_RULES_END  */
  YYSYMBOL_TK_QOS_MATCH_RULE_START = 31,   /* TK_QOS_MATCH_RULE_START  */
  YYSYMBOL_TK_QOS_MATCH_RULE_END = 32,     /* TK_QOS_MATCH_RULE_END  */
  YYSYMBOL_TK_NAME = 33,                   /* TK_NAME  */
  YYSYMBOL_TK_USE = 34,                    /* TK_USE  */
  YYSYMBOL_TK_PORT_GUID = 35,              /* TK_PORT_GUID  */
  YYSYMBOL_TK_PORT_NAME = 36,              /* TK_PORT_NAME  */
  YYSYMBOL_TK_PARTITION = 37,              /* TK_PARTITION  */
  YYSYMBOL_TK_NODE_TYPE = 38,              /* TK_NODE_TYPE  */
  YYSYMBOL_TK_GROUP = 39,                  /* TK_GROUP  */
  YYSYMBOL_TK_ACROSS = 40,                 /* TK_ACROSS  */
  YYSYMBOL_TK_VLARB_HIGH = 41,             /* TK_VLARB_HIGH  */
  YYSYMBOL_TK_VLARB_LOW = 42,              /* TK_VLARB_LOW  */
  YYSYMBOL_TK_VLARB_HIGH_LIMIT = 43,       /* TK_VLARB_HIGH_LIMIT  */
  YYSYMBOL_TK_TO = 44,                     /* TK_TO  */
  YYSYMBOL_TK_FROM = 45,                   /* TK_FROM  */
  YYSYMBOL_TK_ACROSS_TO = 46,              /* TK_ACROSS_TO  */
  YYSYMBOL_TK_ACROSS_FROM = 47,            /* TK_ACROSS_FROM  */
  YYSYMBOL_TK_SL2VL_TABLE = 48,            /* TK_SL2VL_TABLE  */
  YYSYMBOL_TK_SL = 49,                     /* TK_SL  */
  YYSYMBOL_TK_MTU_LIMIT = 50,              /* TK_MTU_LIMIT  */
  YYSYMBOL_TK_RATE_LIMIT = 51,             /* TK_RATE_LIMIT  */
  YYSYMBOL_TK_PACKET_LIFE = 52,            /* TK_PACKET_LIFE  */
  YYSYMBOL_TK_PATH_BITS = 53,              /* TK_PATH_BITS  */
  YYSYMBOL_TK_QOS_CLASS = 54,              /* TK_QOS_CLASS  */
  YYSYMBOL_TK_SOURCE = 55,                 /* TK_SOURCE  */
  YYSYMBOL_TK_DESTINATION = 56,            /* TK_DESTINATION  */
  YYSYMBOL_TK_SERVICE_ID = 57,             /* TK_SERVICE_ID  */
  YYSYMBOL_TK_QOS_LEVEL_NAME = 58,         /* TK_QOS_LEVEL_NAME  */
  YYSYMBOL_TK_PKEY = 59,                   /* TK_PKEY  */
  YYSYMBOL_TK_NODE_TYPE_ROUTER = 60,       /* TK_NODE_TYPE_ROUTER  */
  YYSYMBOL_TK_NODE_TYPE_CA = 61,           /* TK_NODE_TYPE_CA  */
  YYSYMBOL_TK_NODE_TYPE_SWITCH = 62,       /* TK_NODE_TYPE_SWITCH  */
  YYSYMBOL_TK_NODE_TYPE_SELF = 63,         /* TK_NODE_TYPE_SELF  */
  YYSYMBOL_TK_NODE_TYPE_ALL = 64,          /* TK_NODE_TYPE_ALL  */
  YYSYMBOL_TK_ULP_DEFAULT = 65,            /* TK_ULP_DEFAULT  */
  YYSYMBOL_TK_ULP_ANY_SERVICE_ID = 66,     /* TK_ULP_ANY_SERVICE_ID  */
  YYSYMBOL_TK_ULP_ANY_PKEY = 67,           /* TK_ULP_ANY_PKEY  */
  YYSYMBOL_TK_ULP_ANY_TARGET_PORT_GUID = 68, /* TK_ULP_ANY_TARGET_PORT_GUID  */
  YYSYMBOL_TK_ULP_ANY_SOURCE_PORT_GUID = 69, /* TK_ULP_ANY_SOURCE_PORT_GUID  */
  YYSYMBOL_TK_ULP_ANY_SOURCE_TARGET_PORT_GUID = 70, /* TK_ULP_ANY_SOURCE_TARGET_PORT_GUID  */
  YYSYMBOL_TK_ULP_SDP_DEFAULT = 71,        /* TK_ULP_SDP_DEFAULT  */
  YYSYMBOL_TK_ULP_SDP_PORT = 72,           /* TK_ULP_SDP_PORT  */
  YYSYMBOL_TK_ULP_RDS_DEFAULT = 73,        /* TK_ULP_RDS_DEFAULT  */
  YYSYMBOL_TK_ULP_RDS_PORT = 74,           /* TK_ULP_RDS_PORT  */
  YYSYMBOL_TK_ULP_ISER_DEFAULT = 75,       /* TK_ULP_ISER_DEFAULT  */
  YYSYMBOL_TK_ULP_ISER_PORT = 76,          /* TK_ULP_ISER_PORT  */
  YYSYMBOL_TK_ULP_SRP_GUID = 77,           /* TK_ULP_SRP_GUID  */
  YYSYMBOL_TK_ULP_IPOIB_DEFAULT = 78,      /* TK_ULP_IPOIB_DEFAULT  */
  YYSYMBOL_TK_ULP_IPOIB_PKEY = 79,         /* TK_ULP_IPOIB_PKEY  */
  YYSYMBOL_YYACCEPT = 80,                  /* $accept  */
  YYSYMBOL_head = 81,                      /* head  */
  YYSYMBOL_qos_policy_entries = 82,        /* qos_policy_entries  */
  YYSYMBOL_qos_policy_entry = 83,          /* qos_policy_entry  */
  YYSYMBOL_qos_ulps_section = 84,          /* qos_ulps_section  */
  YYSYMBOL_qos_ulps = 85,                  /* qos_ulps  */
  YYSYMBOL_port_groups_section = 86,       /* port_groups_section  */
  YYSYMBOL_port_groups = 87,               /* port_groups  */
  YYSYMBOL_port_group = 88,                /* port_group  */
  YYSYMBOL_port_group_start = 89,          /* port_group_start  */
  YYSYMBOL_port_group_end = 90,            /* port_group_end  */
  YYSYMBOL_port_group_entries = 91,        /* port_group_entries  */
  YYSYMBOL_port_group_entry = 92,          /* port_group_entry  */
  YYSYMBOL_qos_setup_section = 93,         /* qos_setup_section  */
  YYSYMBOL_qos_setup_items = 94,           /* qos_setup_items  */
  YYSYMBOL_vlarb_tables = 95,              /* vlarb_tables  */
  YYSYMBOL_vlarb_scope_items = 96,         /* vlarb_scope_items  */
  YYSYMBOL_vlarb_scope = 97,               /* vlarb_scope  */
  YYSYMBOL_vlarb_scope_start = 98,         /* vlarb_scope_start  */
  YYSYMBOL_vlarb_scope_end = 99,           /* vlarb_scope_end  */
  YYSYMBOL_vlarb_scope_entries = 100,      /* vlarb_scope_entries  */
  YYSYMBOL_vlarb_scope_entry = 101,        /* vlarb_scope_entry  */
  YYSYMBOL_sl2vl_tables = 102,             /* sl2vl_tables  */
  YYSYMBOL_sl2vl_scope_items = 103,        /* sl2vl_scope_items  */
  YYSYMBOL_sl2vl_scope = 104,              /* sl2vl_scope  */
  YYSYMBOL_sl2vl_scope_start = 105,        /* sl2vl_scope_start  */
  YYSYMBOL_sl2vl_scope_end = 106,          /* sl2vl_scope_end  */
  YYSYMBOL_sl2vl_scope_entries = 107,      /* sl2vl_scope_entries  */
  YYSYMBOL_sl2vl_scope_entry = 108,        /* sl2vl_scope_entry  */
  YYSYMBOL_qos_levels_section = 109,       /* qos_levels_section  */
  YYSYMBOL_qos_levels = 110,               /* qos_levels  */
  YYSYMBOL_qos_level = 111,                /* qos_level  */
  YYSYMBOL_qos_level_start = 112,          /* qos_level_start  */
  YYSYMBOL_qos_level_end = 113,            /* qos_level_end  */
  YYSYMBOL_qos_level_entries = 114,        /* qos_level_entries  */
  YYSYMBOL_qos_level_entry = 115,          /* qos_level_entry  */
  YYSYMBOL_qos_match_rules_section = 116,  /* qos_match_rules_section  */
  YYSYMBOL_qos_match_rules = 117,          /* qos_match_rules  */
  YYSYMBOL_qos_match_rule = 118,           /* qos_match_rule  */
  YYSYMBOL_qos_match_rule_start = 119,     /* qos_match_rule_start  */
  YYSYMBOL_qos_match_rule_end = 120,       /* qos_match_rule_end  */
  YYSYMBOL_qos_match_rule_entries = 121,   /* qos_match_rule_entries  */
  YYSYMBOL_qos_match_rule_entry = 122,     /* qos_match_rule_entry  */
  YYSYMBOL_qos_ulp = 123,                  /* qos_ulp  */
  YYSYMBOL_124_1 = 124,                    /* $@1  */
  YYSYMBOL_125_2 = 125,                    /* $@2  */
  YYSYMBOL_126_3 = 126,                    /* $@3  */
  YYSYMBOL_127_4 = 127,                    /* $@4  */
  YYSYMBOL_128_5 = 128,                    /* $@5  */
  YYSYMBOL_129_6 = 129,                    /* $@6  */
  YYSYMBOL_130_7 = 130,                    /* $@7  */
  YYSYMBOL_131_8 = 131,                    /* $@8  */
  YYSYMBOL_132_9 = 132,                    /* $@9  */
  YYSYMBOL_133_10 = 133,                   /* $@10  */
  YYSYMBOL_134_11 = 134,                   /* $@11  */
  YYSYMBOL_135_12 = 135,                   /* $@12  */
  YYSYMBOL_136_13 = 136,                   /* $@13  */
  YYSYMBOL_137_14 = 137,                   /* $@14  */
  YYSYMBOL_qos_ulp_type_any_service = 138, /* qos_ulp_type_any_service  */
  YYSYMBOL_qos_ulp_type_any_pkey = 139,    /* qos_ulp_type_any_pkey  */
  YYSYMBOL_qos_ulp_type_any_target_port_guid = 140, /* qos_ulp_type_any_target_port_guid  */
  YYSYMBOL_qos_ulp_type_any_source_port_guid = 141, /* qos_ulp_type_any_source_port_guid  */
  YYSYMBOL_qos_ulp_type_any_source_target_port_guid = 142, /* qos_ulp_type_any_source_target_port_guid  */
  YYSYMBOL_qos_ulp_type_sdp_default = 143, /* qos_ulp_type_sdp_default  */
  YYSYMBOL_qos_ulp_type_sdp_port = 144,    /* qos_ulp_type_sdp_port  */
  YYSYMBOL_qos_ulp_type_rds_default = 145, /* qos_ulp_type_rds_default  */
  YYSYMBOL_qos_ulp_type_rds_port = 146,    /* qos_ulp_type_rds_port  */
  YYSYMBOL_qos_ulp_type_iser_default = 147, /* qos_ulp_type_iser_default  */
  YYSYMBOL_qos_ulp_type_iser_port = 148,   /* qos_ulp_type_iser_port  */
  YYSYMBOL_qos_ulp_type_srp_guid = 149,    /* qos_ulp_type_srp_guid  */
  YYSYMBOL_qos_ulp_type_ipoib_default = 150, /* qos_ulp_type_ipoib_default  */
  YYSYMBOL_qos_ulp_type_ipoib_pkey = 151,  /* qos_ulp_type_ipoib_pkey  */
  YYSYMBOL_qos_ulp_sl = 152,               /* qos_ulp_sl  */
  YYSYMBOL_port_group_name = 153,          /* port_group_name  */
  YYSYMBOL_port_group_name_start = 154,    /* port_group_name_start  */
  YYSYMBOL_port_group_use = 155,           /* port_group_use  */
  YYSYMBOL_port_group_use_start = 156,     /* port_group_use_start  */
  YYSYMBOL_port_group_port_name = 157,     /* port_group_port_name  */
  YYSYMBOL_port_group_port_name_start = 158, /* port_group_port_name_start  */
  YYSYMBOL_port_group_port_guid = 159,     /* port_group_port_guid  */
  YYSYMBOL_port_group_port_guid_start = 160, /* port_group_port_guid_start  */
  YYSYMBOL_port_group_pkey = 161,          /* port_group_pkey  */
  YYSYMBOL_port_group_pkey_start = 162,    /* port_group_pkey_start  */
  YYSYMBOL_port_group_partition = 163,     /* port_group_partition  */
  YYSYMBOL_port_group_partition_start = 164, /* port_group_partition_start  */
  YYSYMBOL_port_group_node_type = 165,     /* port_group_node_type  */
  YYSYMBOL_port_group_node_type_start = 166, /* port_group_node_type_start  */
  YYSYMBOL_port_group_node_type_list = 167, /* port_group_node_type_list  */
  YYSYMBOL_node_type_item = 168,           /* node_type_item  */
  YYSYMBOL_node_type_ca = 169,             /* node_type_ca  */
  YYSYMBOL_node_type_switch = 170,         /* node_type_switch  */
  YYSYMBOL_node_type_router = 171,         /* node_type_router  */
  YYSYMBOL_node_type_all = 172,            /* node_type_all  */
  YYSYMBOL_node_type_self = 173,           /* node_type_self  */
  YYSYMBOL_vlarb_scope_group = 174,        /* vlarb_scope_group  */
  YYSYMBOL_vlarb_scope_group_start = 175,  /* vlarb_scope_group_start  */
  YYSYMBOL_vlarb_scope_across = 176,       /* vlarb_scope_across  */
  YYSYMBOL_vlarb_scope_across_start = 177, /* vlarb_scope_across_start  */
  YYSYMBOL_vlarb_scope_vlarb_high_limit = 178, /* vlarb_scope_vlarb_high_limit  */
  YYSYMBOL_vlarb_scope_vlarb_high_limit_start = 179, /* vlarb_scope_vlarb_high_limit_start  */
  YYSYMBOL_vlarb_scope_vlarb_high = 180,   /* vlarb_scope_vlarb_high  */
  YYSYMBOL_vlarb_scope_vlarb_high_start = 181, /* vlarb_scope_vlarb_high_start  */
  YYSYMBOL_vlarb_scope_vlarb_low = 182,    /* vlarb_scope_vlarb_low  */
  YYSYMBOL_vlarb_scope_vlarb_low_start = 183, /* vlarb_scope_vlarb_low_start  */
  YYSYMBOL_sl2vl_scope_group = 184,        /* sl2vl_scope_group  */
  YYSYMBOL_sl2vl_scope_group_start = 185,  /* sl2vl_scope_group_start  */
  YYSYMBOL_sl2vl_scope_across = 186,       /* sl2vl_scope_across  */
  YYSYMBOL_sl2vl_scope_across_start = 187, /* sl2vl_scope_across_start  */
  YYSYMBOL_sl2vl_scope_across_from = 188,  /* sl2vl_scope_across_from  */
  YYSYMBOL_sl2vl_scope_across_from_start = 189, /* sl2vl_scope_across_from_start  */
  YYSYMBOL_sl2vl_scope_across_to = 190,    /* sl2vl_scope_across_to  */
  YYSYMBOL_sl2vl_scope_across_to_start = 191, /* sl2vl_scope_across_to_start  */
  YYSYMBOL_sl2vl_scope_from = 192,         /* sl2vl_scope_from  */
  YYSYMBOL_sl2vl_scope_from_start = 193,   /* sl2vl_scope_from_start  */
  YYSYMBOL_sl2vl_scope_to = 194,           /* sl2vl_scope_to  */
  YYSYMBOL_sl2vl_scope_to_start = 195,     /* sl2vl_scope_to_start  */
  YYSYMBOL_sl2vl_scope_from_list_or_asterisk = 196, /* sl2vl_scope_from_list_or_asterisk  */
  YYSYMBOL_sl2vl_scope_from_asterisk = 197, /* sl2vl_scope_from_asterisk  */
  YYSYMBOL_sl2vl_scope_to_list_or_asterisk = 198, /* sl2vl_scope_to_list_or_asterisk  */
  YYSYMBOL_sl2vl_scope_to_asterisk = 199,  /* sl2vl_scope_to_asterisk  */
  YYSYMBOL_sl2vl_scope_from_list_of_ranges = 200, /* sl2vl_scope_from_list_of_ranges  */
  YYSYMBOL_sl2vl_scope_to_list_of_ranges = 201, /* sl2vl_scope_to_list_of_ranges  */
  YYSYMBOL_sl2vl_scope_sl2vl_table = 202,  /* sl2vl_scope_sl2vl_table  */
  YYSYMBOL_sl2vl_scope_sl2vl_table_start = 203, /* sl2vl_scope_sl2vl_table_start  */
  YYSYMBOL_qos_level_name = 204,           /* qos_level_name  */
  YYSYMBOL_qos_level_name_start = 205,     /* qos_level_name_start  */
  YYSYMBOL_qos_level_use = 206,            /* qos_level_use  */
  YYSYMBOL_qos_level_use_start = 207,      /* qos_level_use_start  */
  YYSYMBOL_qos_level_sl = 208,             /* qos_level_sl  */
  YYSYMBOL_qos_level_sl_start = 209,       /* qos_level_sl_start  */
  YYSYMBOL_qos_level_mtu_limit = 210,      /* qos_level_mtu_limit  */
  YYSYMBOL_qos_level_mtu_limit_start = 211, /* qos_level_mtu_limit_start  */
  YYSYMBOL_qos_level_rate_limit = 212,     /* qos_level_rate_limit  */
  YYSYMBOL_qos_level_rate_limit_start = 213, /* qos_level_rate_limit_start  */
  YYSYMBOL_qos_level_packet_life = 214,    /* qos_level_packet_life  */
  YYSYMBOL_qos_level_packet_life_start = 215, /* qos_level_packet_life_start  */
  YYSYMBOL_qos_level_path_bits = 216,      /* qos_level_path_bits  */
  YYSYMBOL_qos_level_path_bits_start = 217, /* qos_level_path_bits_start  */
  YYSYMBOL_qos_level_pkey = 218,           /* qos_level_pkey  */
  YYSYMBOL_qos_level_pkey_start = 219,     /* qos_level_pkey_start  */
  YYSYMBOL_qos_match_rule_use = 220,       /* qos_match_rule_use  */
  YYSYMBOL_qos_match_rule_use_start = 221, /* qos_match_rule_use_start  */
  YYSYMBOL_qos_match_rule_qos_class = 222, /* qos_match_rule_qos_class  */
  YYSYMBOL_qos_match_rule_qos_class_start = 223, /* qos_match_rule_qos_class_start  */
  YYSYMBOL_qos_match_rule_source = 224,    /* qos_match_rule_source  */
  YYSYMBOL_qos_match_rule_source_start = 225, /* qos_match_rule_source_start  */
  YYSYMBOL_qos_match_rule_destination = 226, /* qos_match_rule_destination  */
  YYSYMBOL_qos_match_rule_destination_start = 227, /* qos_match_rule_destination_start  */
  YYSYMBOL_qos_match_rule_qos_level_name = 228, /* qos_match_rule_qos_level_name  */
  YYSYMBOL_qos_match_rule_qos_level_name_start = 229, /* qos_match_rule_qos_level_name_start  */
  YYSYMBOL_qos_match_rule_service_id = 230, /* qos_match_rule_service_id  */
  YYSYMBOL_qos_match_rule_service_id_start = 231, /* qos_match_rule_service_id_start  */
  YYSYMBOL_qos_match_rule_pkey = 232,      /* qos_match_rule_pkey  */
  YYSYMBOL_qos_match_rule_pkey_start = 233, /* qos_match_rule_pkey_start  */
  YYSYMBOL_single_string = 234,            /* single_string  */
  YYSYMBOL_single_string_elems = 235,      /* single_string_elems  */
  YYSYMBOL_single_string_element = 236,    /* single_string_element  */
  YYSYMBOL_string_list = 237,              /* string_list  */
  YYSYMBOL_single_number = 238,            /* single_number  */
  YYSYMBOL_num_list = 239,                 /* num_list  */
  YYSYMBOL_number = 240,                   /* number  */
  YYSYMBOL_num_list_with_dotdot = 241,     /* num_list_with_dotdot  */
  YYSYMBOL_number_from_pair_1 = 242,       /* number_from_pair_1  */
  YYSYMBOL_number_from_pair_2 = 243,       /* number_from_pair_2  */
  YYSYMBOL_list_of_ranges = 244,           /* list_of_ranges  */
  YYSYMBOL_num_list_with_dash = 245,       /* num_list_with_dash  */
  YYSYMBOL_single_number_from_range = 246, /* single_number_from_range  */
  YYSYMBOL_number_from_range_1 = 247,      /* number_from_range_1  */
  YYSYMBOL_number_from_range_2 = 248       /* number_from_range_2  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   275

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  80
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  169
/* YYNRULES -- Number of rules.  */
#define YYNRULES  244
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  340

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   334


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   285,   285,   288,   289,   292,   293,   294,   295,   296,
     322,   325,   326,   355,   358,   359,   362,   365,   370,   376,
     377,   380,   381,   382,   383,   384,   385,   386,   413,   416,
     417,   418,   423,   426,   427,   430,   433,   438,   444,   445,
     460,   461,   462,   463,   464,   469,   472,   473,   476,   479,
     484,   490,   491,   510,   511,   512,   513,   514,   515,   516,
     540,   543,   544,   547,   550,   555,   561,   562,   565,   566,
     567,   568,   569,   570,   571,   572,   594,   597,   598,   601,
     604,   609,   615,   616,   619,   620,   621,   622,   623,   624,
     625,   649,   667,   667,   688,   688,   709,   709,   744,   744,
     779,   779,   817,   817,   830,   830,   864,   864,   877,   877,
     911,   911,   924,   924,   958,   958,   994,   994,  1017,  1017,
    1050,  1053,  1056,  1059,  1062,  1065,  1068,  1071,  1074,  1077,
    1080,  1083,  1086,  1089,  1093,  1132,  1155,  1160,  1183,  1188,
    1254,  1259,  1279,  1284,  1304,  1309,  1317,  1322,  1327,  1332,
    1333,  1336,  1337,  1338,  1339,  1340,  1343,  1349,  1355,  1361,
    1369,  1391,  1408,  1413,  1430,  1435,  1453,  1458,  1475,  1480,
    1497,  1513,  1530,  1535,  1554,  1559,  1576,  1581,  1599,  1604,
    1609,  1614,  1619,  1624,  1625,  1628,  1635,  1636,  1639,  1646,
    1677,  1709,  1752,  1769,  1792,  1797,  1820,  1825,  1845,  1850,
    1877,  1883,  1910,  1916,  1936,  1942,  1977,  1982,  2015,  2032,
    2055,  2060,  2094,  2099,  2116,  2121,  2138,  2143,  2166,  2171,
    2204,  2209,  2242,  2253,  2260,  2261,  2264,  2271,  2272,  2277,
    2280,  2281,  2284,  2292,  2298,  2306,  2312,  2318,  2321,  2327,
    2339,  2351,  2359,  2366,  2372
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TK_NUMBER", "TK_DASH",
  "TK_DOTDOT", "TK_COMMA", "TK_ASTERISK", "TK_TEXT", "TK_QOS_ULPS_START",
  "TK_QOS_ULPS_END", "TK_PORT_GROUPS_START", "TK_PORT_GROUPS_END",
  "TK_PORT_GROUP_START", "TK_PORT_GROUP_END", "TK_QOS_SETUP_START",
  "TK_QOS_SETUP_END", "TK_VLARB_TABLES_START", "TK_VLARB_TABLES_END",
  "TK_VLARB_SCOPE_START", "TK_VLARB_SCOPE_END", "TK_SL2VL_TABLES_START",
  "TK_SL2VL_TABLES_END", "TK_SL2VL_SCOPE_START", "TK_SL2VL_SCOPE_END",
  "TK_QOS_LEVELS_START", "TK_QOS_LEVELS_END", "TK_QOS_LEVEL_START",
  "TK_QOS_LEVEL_END", "TK_QOS_MATCH_RULES_START", "TK_QOS_MATCH_RULES_END",
  "TK_QOS_MATCH_RULE_START", "TK_QOS_MATCH_RULE_END", "TK_NAME", "TK_USE",
  "TK_PORT_GUID", "TK_PORT_NAME", "TK_PARTITION", "TK_NODE_TYPE",
  "TK_GROUP", "TK_ACROSS", "TK_VLARB_HIGH", "TK_VLARB_LOW",
  "TK_VLARB_HIGH_LIMIT", "TK_TO", "TK_FROM", "TK_ACROSS_TO",
  "TK_ACROSS_FROM", "TK_SL2VL_TABLE", "TK_SL", "TK_MTU_LIMIT",
  "TK_RATE_LIMIT", "TK_PACKET_LIFE", "TK_PATH_BITS", "TK_QOS_CLASS",
  "TK_SOURCE", "TK_DESTINATION", "TK_SERVICE_ID", "TK_QOS_LEVEL_NAME",
  "TK_PKEY", "TK_NODE_TYPE_ROUTER", "TK_NODE_TYPE_CA",
  "TK_NODE_TYPE_SWITCH", "TK_NODE_TYPE_SELF", "TK_NODE_TYPE_ALL",
  "TK_ULP_DEFAULT", "TK_ULP_ANY_SERVICE_ID", "TK_ULP_ANY_PKEY",
  "TK_ULP_ANY_TARGET_PORT_GUID", "TK_ULP_ANY_SOURCE_PORT_GUID",
  "TK_ULP_ANY_SOURCE_TARGET_PORT_GUID", "TK_ULP_SDP_DEFAULT",
  "TK_ULP_SDP_PORT", "TK_ULP_RDS_DEFAULT", "TK_ULP_RDS_PORT",
  "TK_ULP_ISER_DEFAULT", "TK_ULP_ISER_PORT", "TK_ULP_SRP_GUID",
  "TK_ULP_IPOIB_DEFAULT", "TK_ULP_IPOIB_PKEY", "$accept", "head",
  "qos_policy_entries", "qos_policy_entry", "qos_ulps_section", "qos_ulps",
  "port_groups_section", "port_groups", "port_group", "port_group_start",
  "port_group_end", "port_group_entries", "port_group_entry",
  "qos_setup_section", "qos_setup_items", "vlarb_tables",
  "vlarb_scope_items", "vlarb_scope", "vlarb_scope_start",
  "vlarb_scope_end", "vlarb_scope_entries", "vlarb_scope_entry",
  "sl2vl_tables", "sl2vl_scope_items", "sl2vl_scope", "sl2vl_scope_start",
  "sl2vl_scope_end", "sl2vl_scope_entries", "sl2vl_scope_entry",
  "qos_levels_section", "qos_levels", "qos_level", "qos_level_start",
  "qos_level_end", "qos_level_entries", "qos_level_entry",
  "qos_match_rules_section", "qos_match_rules", "qos_match_rule",
  "qos_match_rule_start", "qos_match_rule_end", "qos_match_rule_entries",
  "qos_match_rule_entry", "qos_ulp", "$@1", "$@2", "$@3", "$@4", "$@5",
  "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13", "$@14",
  "qos_ulp_type_any_service", "qos_ulp_type_any_pkey",
  "qos_ulp_type_any_target_port_guid", "qos_ulp_type_any_source_port_guid",
  "qos_ulp_type_any_source_target_port_guid", "qos_ulp_type_sdp_default",
  "qos_ulp_type_sdp_port", "qos_ulp_type_rds_default",
  "qos_ulp_type_rds_port", "qos_ulp_type_iser_default",
  "qos_ulp_type_iser_port", "qos_ulp_type_srp_guid",
  "qos_ulp_type_ipoib_default", "qos_ulp_type_ipoib_pkey", "qos_ulp_sl",
  "port_group_name", "port_group_name_start", "port_group_use",
  "port_group_use_start", "port_group_port_name",
  "port_group_port_name_start", "port_group_port_guid",
  "port_group_port_guid_start", "port_group_pkey", "port_group_pkey_start",
  "port_group_partition", "port_group_partition_start",
  "port_group_node_type", "port_group_node_type_start",
  "port_group_node_type_list", "node_type_item", "node_type_ca",
  "node_type_switch", "node_type_router", "node_type_all",
  "node_type_self", "vlarb_scope_group", "vlarb_scope_group_start",
  "vlarb_scope_across", "vlarb_scope_across_start",
  "vlarb_scope_vlarb_high_limit", "vlarb_scope_vlarb_high_limit_start",
  "vlarb_scope_vlarb_high", "vlarb_scope_vlarb_high_start",
  "vlarb_scope_vlarb_low", "vlarb_scope_vlarb_low_start",
  "sl2vl_scope_group", "sl2vl_scope_group_start", "sl2vl_scope_across",
  "sl2vl_scope_across_start", "sl2vl_scope_across_from",
  "sl2vl_scope_across_from_start", "sl2vl_scope_across_to",
  "sl2vl_scope_across_to_start", "sl2vl_scope_from",
  "sl2vl_scope_from_start", "sl2vl_scope_to", "sl2vl_scope_to_start",
  "sl2vl_scope_from_list_or_asterisk", "sl2vl_scope_from_asterisk",
  "sl2vl_scope_to_list_or_asterisk", "sl2vl_scope_to_asterisk",
  "sl2vl_scope_from_list_of_ranges", "sl2vl_scope_to_list_of_ranges",
  "sl2vl_scope_sl2vl_table", "sl2vl_scope_sl2vl_table_start",
  "qos_level_name", "qos_level_name_start", "qos_level_use",
  "qos_level_use_start", "qos_level_sl", "qos_level_sl_start",
  "qos_level_mtu_limit", "qos_level_mtu_limit_start",
  "qos_level_rate_limit", "qos_level_rate_limit_start",
  "qos_level_packet_life", "qos_level_packet_life_start",
  "qos_level_path_bits", "qos_level_path_bits_start", "qos_level_pkey",
  "qos_level_pkey_start", "qos_match_rule_use", "qos_match_rule_use_start",
  "qos_match_rule_qos_class", "qos_match_rule_qos_class_start",
  "qos_match_rule_source", "qos_match_rule_source_start",
  "qos_match_rule_destination", "qos_match_rule_destination_start",
  "qos_match_rule_qos_level_name", "qos_match_rule_qos_level_name_start",
  "qos_match_rule_service_id", "qos_match_rule_service_id_start",
  "qos_match_rule_pkey", "qos_match_rule_pkey_start", "single_string",
  "single_string_elems", "single_string_element", "string_list",
  "single_number", "num_list", "number", "num_list_with_dotdot",
  "number_from_pair_1", "number_from_pair_2", "list_of_ranges",
  "num_list_with_dash", "single_number_from_range", "number_from_range_1",
  "number_from_range_2", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-294)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-244)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -294,    18,    13,  -294,    87,     7,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,    20,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
      66,  -294,    26,    26,    26,    26,    26,  -294,    26,  -294,
      26,  -294,    26,    26,  -294,    26,  -294,    41,  -294,  -294,
       0,    29,    35,  -294,  -294,  -294,  -294,  -294,    27,    52,
      53,  -294,    69,    70,    72,    73,    75,    20,    79,    20,
      80,    20,    81,    89,    20,    91,  -294,  -294,    -1,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,    26,    71,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
      90,  -294,    90,  -294,    90,  -294,    26,  -294,    26,  -294,
      90,  -294,   116,    50,    49,    11,    -7,    20,  -294,    88,
    -294,  -294,    20,    20,    20,    20,    20,    20,    20,    20,
      20,  -294,  -294,    90,  -294,  -294,  -294,    94,  -294,  -294,
      94,  -294,  -294,  -294,  -294,  -294,    95,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,    90,  -294,    90,  -294,    20,  -294,    20,
    -294,    20,  -294,    20,  -294,    26,  -294,    26,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,    90,
    -294,    26,  -294,    90,  -294,    90,  -294,    90,  -294,    26,
    -294,    26,  -294,    71,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,    90,   116,    84,    43,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,    94,    94,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,    90,  -294,    90,  -294,    20,
    -294,    99,  -294,    99,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,    90,  -294,    90,  -294,    90,
    -294,    90,  -294,    12,  -294,    23,  -294,    20,    94,    94,
    -294,  -294,    97,   101,    97,    94,    94,    94,    94,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,   102,
    -294,    99,   104,    20,   105,  -294,  -294,  -294,   104,  -294
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     2,     1,     0,     0,    29,    61,    77,     4,
       5,     6,     7,     8,     9,     0,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
       0,    11,     0,     0,     0,     0,     0,   102,     0,   106,
       0,   110,     0,     0,   116,     0,    17,     0,    14,    19,
       0,     0,     0,   232,    91,   229,    10,    12,   242,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    13,    15,     0,    28,
      33,    46,    30,    31,    60,    64,    62,    66,    76,    80,
      78,    82,    92,     0,     0,    94,    96,    98,   100,   103,
     134,   104,   107,   108,   111,   112,   114,   117,   118,    18,
     136,   138,   142,   140,   146,   148,   144,    16,    20,    21,
       0,    22,     0,    24,     0,    23,     0,    25,     0,    26,
       0,    27,     0,     0,     0,     0,     0,     0,   241,     0,
     244,   239,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   226,   135,   223,   224,   137,   227,   139,   141,   143,
     145,   158,   156,   157,   160,   159,   147,   149,   151,   152,
     153,   154,   155,    32,    36,    34,    38,    45,    49,    47,
      51,    65,   194,   196,   198,   200,   202,   204,   206,   208,
      63,    67,    68,     0,    69,     0,    70,     0,    71,     0,
      72,     0,    73,     0,    74,     0,    75,     0,    81,   210,
     212,   214,   216,   220,   218,   222,    79,    83,    84,     0,
      85,     0,    87,     0,    88,     0,    86,     0,    89,     0,
      90,     0,    93,     0,    95,    97,    99,   101,   105,   109,
     113,   115,   119,   225,     0,     0,     0,     0,   193,   195,
     197,   199,   201,   203,   205,   207,   209,   211,   213,   215,
     217,   219,   221,   240,   228,   150,    37,   162,   164,   168,
     170,   166,    35,    39,    40,     0,    41,     0,    44,     0,
      42,     0,    43,     0,    50,   172,   174,   182,   180,   178,
     176,   192,    48,    52,    53,     0,    54,     0,    55,     0,
      56,     0,    57,     0,    58,     0,    59,     0,   161,   163,
     165,   235,   167,     0,   169,   171,   173,   175,   177,   185,
     179,   183,   184,   189,   188,   181,   186,   187,   190,   191,
     230,     0,     0,     0,     0,   236,   233,   231,     0,   234
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,    64,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,    82,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,   -28,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -117,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,  -294,
    -294,  -294,  -294,  -294,  -114,  -294,   -24,  -126,    -4,  -294,
    -293,  -137,  -184,  -190,   -33,  -294,    57,    74,   -65
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,     9,    10,    30,    11,    47,    48,    49,
     117,    78,   118,    12,    50,    82,   133,   175,   176,   272,
     246,   273,    83,   134,   179,   180,   292,   247,   293,    13,
      51,    86,    87,   190,   135,   191,    14,    52,    90,    91,
     216,   136,   217,    31,   137,   142,   143,   144,   145,    67,
     146,    69,   147,    71,   148,   149,    74,   150,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    99,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   166,   167,   168,
     169,   170,   171,   172,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   320,   321,   325,   326,
     322,   327,   306,   307,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   156,   153,   154,   157,   100,   329,
      55,   312,   313,   336,    59,    60,    61,    62,   141
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      63,    64,    65,    66,   160,    68,   152,    70,   155,    72,
      73,    54,    75,   109,   330,    58,    79,    80,     3,   319,
      46,    81,     4,    53,     5,   208,    58,   209,     6,    58,
     324,  -243,   110,   111,   112,   113,   114,   115,     7,   181,
     337,   102,     8,   104,   182,   183,   107,   210,   211,   212,
     213,   214,   215,    76,    46,    84,    85,    92,   116,    93,
     184,   185,   186,   187,   188,    88,    89,   284,   173,   174,
     189,   177,   178,    94,   140,    95,    56,    96,    97,   248,
      98,   249,   285,   286,   101,   103,   105,   287,   288,   289,
     290,   291,   233,   158,   106,   159,   108,   258,   151,   259,
     244,   245,   311,   331,   266,   256,   332,   335,   333,   232,
     338,    77,    57,   260,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   267,   268,   269,   270,   271,   265,   243,
     264,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,   314,   334,   339,   308,
     138,   309,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,   139,   263,   315,
       0,   316,   254,   317,   255,   318,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,     0,   257,     0,
       0,     0,     0,   250,     0,   251,   261,   252,   262,   253,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     323,     0,   328,     0,     0,   310
};

static const yytype_int16 yycheck[] =
{
      33,    34,    35,    36,   130,    38,   120,    40,   122,    42,
      43,    15,    45,    14,   307,     3,    16,    17,     0,     7,
      13,    21,     9,     3,    11,    32,     3,    34,    15,     3,
       7,     4,    33,    34,    35,    36,    37,    38,    25,    28,
     333,    69,    29,    71,    33,    34,    74,    54,    55,    56,
      57,    58,    59,    12,    13,    26,    27,     5,    59,     6,
      49,    50,    51,    52,    53,    30,    31,    24,    18,    19,
      59,    22,    23,     4,     3,     5,    10,     5,     5,   193,
       5,   195,    39,    40,     5,     5,     5,    44,    45,    46,
      47,    48,     4,   126,     5,   128,     5,   223,     8,   225,
       6,     6,     3,     6,    20,   219,     5,     3,     6,   137,
       5,    47,    30,   227,   142,   143,   144,   145,   146,   147,
     148,   149,   150,    39,    40,    41,    42,    43,   245,   153,
     244,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,   283,   331,   338,   275,
      93,   277,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    93,   233,   295,
      -1,   297,   205,   299,   207,   301,    60,    61,    62,    63,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,
      -1,    -1,    -1,   197,    -1,   199,   229,   201,   231,   203,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     303,    -1,   305,    -1,    -1,   279
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    81,    82,     0,     9,    11,    15,    25,    29,    83,
      84,    86,    93,   109,   116,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      85,   123,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,    13,    87,    88,    89,
      94,   110,   117,     3,   238,   240,    10,   123,     3,   244,
     245,   246,   247,   244,   244,   244,   244,   129,   244,   131,
     244,   133,   244,   244,   136,   244,    12,    88,    91,    16,
      17,    21,    95,   102,    26,    27,   111,   112,    30,    31,
     118,   119,     5,     6,     4,     5,     5,     5,     5,   152,
     238,     5,   152,     5,   152,     5,     5,   152,     5,    14,
      33,    34,    35,    36,    37,    38,    59,    90,    92,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,    96,   103,   114,   121,   124,   246,   247,
       3,   248,   125,   126,   127,   128,   130,   132,   134,   135,
     137,     8,   234,   235,   236,   234,   234,   237,   244,   244,
     237,    60,    61,    62,    63,    64,   167,   168,   169,   170,
     171,   172,   173,    18,    19,    97,    98,    22,    23,   104,
     105,    28,    33,    34,    49,    50,    51,    52,    53,    59,
     113,   115,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    32,    34,
      54,    55,    56,    57,    58,    59,   120,   122,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   152,     4,   152,   152,   152,   152,   152,   152,
     152,   152,   152,   236,     6,     6,   100,   107,   234,   234,
     238,   238,   238,   238,   244,   244,   234,   244,   237,   237,
     234,   244,   244,   248,   234,   168,    20,    39,    40,    41,
      42,    43,    99,   101,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    24,    39,    40,    44,    45,    46,
      47,    48,   106,   108,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   202,   203,   237,   237,
     238,     3,   241,   242,   241,   237,   237,   237,   237,     7,
     196,   197,   200,   244,     7,   198,   199,   201,   244,   239,
     240,     6,     5,     6,   242,     3,   243,   240,     5,   243
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,    80,    81,    82,    82,    83,    83,    83,    83,    83,
      84,    85,    85,    86,    87,    87,    88,    89,    90,    91,
      91,    92,    92,    92,    92,    92,    92,    92,    93,    94,
      94,    94,    95,    96,    96,    97,    98,    99,   100,   100,
     101,   101,   101,   101,   101,   102,   103,   103,   104,   105,
     106,   107,   107,   108,   108,   108,   108,   108,   108,   108,
     109,   110,   110,   111,   112,   113,   114,   114,   115,   115,
     115,   115,   115,   115,   115,   115,   116,   117,   117,   118,
     119,   120,   121,   121,   122,   122,   122,   122,   122,   122,
     122,   123,   124,   123,   125,   123,   126,   123,   127,   123,
     128,   123,   129,   123,   130,   123,   131,   123,   132,   123,
     133,   123,   134,   123,   135,   123,   136,   123,   137,   123,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     167,   168,   168,   168,   168,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   196,   197,   198,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   235,   236,   237,   237,   238,
     239,   239,   240,   241,   241,   242,   243,   244,   245,   245,
     245,   245,   246,   247,   248
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       3,     1,     2,     3,     1,     2,     3,     1,     1,     0,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     0,
       2,     2,     3,     0,     2,     3,     1,     1,     0,     2,
       1,     1,     1,     1,     1,     3,     0,     2,     3,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     0,     2,     3,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     0,     2,     3,
       1,     1,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     2,     0,     5,     0,     5,     0,     5,     0,     5,
       0,     5,     0,     3,     0,     5,     0,     3,     0,     5,
       0,     3,     0,     5,     0,     5,     0,     3,     0,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     1,     1,     2,     1,     1,     3,     1,
       1,     3,     1,     3,     5,     1,     1,     1,     1,     3,
       5,     3,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 17: /* port_group_start: TK_PORT_GROUP_START  */
#line 365 "osm_qos_parser_y.y"
                                        {
                        __parser_port_group_start();
                    }
#line 2033 "osm_qos_parser_y.c"
    break;

  case 18: /* port_group_end: TK_PORT_GROUP_END  */
#line 370 "osm_qos_parser_y.y"
                                      {
                        if ( __parser_port_group_end() )
                            return 1;
                    }
#line 2042 "osm_qos_parser_y.c"
    break;

  case 36: /* vlarb_scope_start: TK_VLARB_SCOPE_START  */
#line 433 "osm_qos_parser_y.y"
                                         {
                        __parser_vlarb_scope_start();
                    }
#line 2050 "osm_qos_parser_y.c"
    break;

  case 37: /* vlarb_scope_end: TK_VLARB_SCOPE_END  */
#line 438 "osm_qos_parser_y.y"
                                       {
                        if ( __parser_vlarb_scope_end() )
                            return 1;
                    }
#line 2059 "osm_qos_parser_y.c"
    break;

  case 49: /* sl2vl_scope_start: TK_SL2VL_SCOPE_START  */
#line 479 "osm_qos_parser_y.y"
                                         {
                        __parser_sl2vl_scope_start();
                    }
#line 2067 "osm_qos_parser_y.c"
    break;

  case 50: /* sl2vl_scope_end: TK_SL2VL_SCOPE_END  */
#line 484 "osm_qos_parser_y.y"
                                       {
                        if ( __parser_sl2vl_scope_end() )
                            return 1;
                    }
#line 2076 "osm_qos_parser_y.c"
    break;

  case 64: /* qos_level_start: TK_QOS_LEVEL_START  */
#line 550 "osm_qos_parser_y.y"
                                       {
                        __parser_qos_level_start();
                    }
#line 2084 "osm_qos_parser_y.c"
    break;

  case 65: /* qos_level_end: TK_QOS_LEVEL_END  */
#line 555 "osm_qos_parser_y.y"
                                     {
                        if ( __parser_qos_level_end() )
                            return 1;
                    }
#line 2093 "osm_qos_parser_y.c"
    break;

  case 80: /* qos_match_rule_start: TK_QOS_MATCH_RULE_START  */
#line 604 "osm_qos_parser_y.y"
                                              {
                        __parser_match_rule_start();
                    }
#line 2101 "osm_qos_parser_y.c"
    break;

  case 81: /* qos_match_rule_end: TK_QOS_MATCH_RULE_END  */
#line 609 "osm_qos_parser_y.y"
                                          {
                        if ( __parser_match_rule_end() )
                            return 1;
                    }
#line 2110 "osm_qos_parser_y.c"
    break;

  case 91: /* qos_ulp: TK_ULP_DEFAULT single_number  */
#line 649 "osm_qos_parser_y.y"
                                                 {
                        /* parsing default ulp rule: "default: num" */
                        cl_list_iterator_t    list_iterator;
                        uint64_t            * p_tmp_num;

                        list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                        p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                        if (*p_tmp_num > 15)
                        {
                            yyerror("illegal SL value");
                            return 1;
                        }
                        __default_simple_qos_level.sl = (uint8_t)(*p_tmp_num);
                        __default_simple_qos_level.sl_set = TRUE;
                        free(p_tmp_num);
                        cl_list_remove_all(&tmp_parser_struct.num_list);
                    }
#line 2132 "osm_qos_parser_y.c"
    break;

  case 92: /* $@1: %empty  */
#line 667 "osm_qos_parser_y.y"
                                                                        {
                        /* "any, service-id ... : sl" - one instance of list of ranges */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have service ids");
                            return 1;
                        }

                        /* get all the service id ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2157 "osm_qos_parser_y.c"
    break;

  case 94: /* $@2: %empty  */
#line 688 "osm_qos_parser_y.y"
                                                                     {
                        /* "any, pkey ... : sl" - one instance of list of ranges */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have pkeys");
                            return 1;
                        }

                        /* get all the pkey ranges */
                        __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = range_len;

                    }
#line 2182 "osm_qos_parser_y.c"
    break;

  case 96: /* $@3: %empty  */
#line 709 "osm_qos_parser_y.y"
                                                                                 {
                        /* any, target-port-guid ... : sl */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have port guids");
                            return 1;
                        }

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

                    }
#line 2221 "osm_qos_parser_y.c"
    break;

  case 98: /* $@4: %empty  */
#line 744 "osm_qos_parser_y.y"
                                                                                 {
			/* any, source-port-guid ... : sl */
			uint64_t ** range_arr;
			unsigned    range_len;

			if (!cl_list_count(&tmp_parser_struct.num_pair_list))
			{
				yyerror("ULP rule doesn't have port guids");
				return 1;
			}

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Sources_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the source
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->source_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

		    }
#line 2260 "osm_qos_parser_y.c"
    break;

  case 100: /* $@5: %empty  */
#line 779 "osm_qos_parser_y.y"
                                                                                        {
			/* any, source-target-port-guid ... : sl */
			uint64_t ** range_arr;
			unsigned    range_len;

			if (!cl_list_count(&tmp_parser_struct.num_pair_list))
			{
				yyerror("ULP rule doesn't have port guids");
				return 1;
			}

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Sources_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the source and destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->source_group_list,
                                            p_current_port_group);

                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

		    }
#line 2302 "osm_qos_parser_y.c"
    break;

  case 102: /* $@6: %empty  */
#line 817 "osm_qos_parser_y.y"
                                               {
                        /* "sdp : sl" - default SL for SDP */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                        range_arr[0][1] = OSM_QOS_POLICY_ULP_SDP_SERVICE_ID + 0xFFFF;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2319 "osm_qos_parser_y.c"
    break;

  case 104: /* $@7: %empty  */
#line 830 "osm_qos_parser_y.y"
                                                                     {
                        /* sdp with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("SDP ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2357 "osm_qos_parser_y.c"
    break;

  case 106: /* $@8: %empty  */
#line 864 "osm_qos_parser_y.y"
                                               {
                        /* "rds : sl" - default SL for RDS */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] =
                           OSM_QOS_POLICY_ULP_RDS_SERVICE_ID + OSM_QOS_POLICY_ULP_RDS_PORT;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2374 "osm_qos_parser_y.c"
    break;

  case 108: /* $@9: %empty  */
#line 877 "osm_qos_parser_y.y"
                                                                     {
                        /* rds with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("RDS ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_RDS_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_RDS_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2412 "osm_qos_parser_y.c"
    break;

  case 110: /* $@10: %empty  */
#line 911 "osm_qos_parser_y.y"
                                                {
                        /* "iSER : sl" - default SL for iSER */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] =
                           OSM_QOS_POLICY_ULP_ISER_SERVICE_ID + OSM_QOS_POLICY_ULP_ISER_PORT;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2429 "osm_qos_parser_y.c"
    break;

  case 112: /* $@11: %empty  */
#line 924 "osm_qos_parser_y.y"
                                                                      {
                        /* iser with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("iSER ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_ISER_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_ISER_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2467 "osm_qos_parser_y.c"
    break;

  case 114: /* $@12: %empty  */
#line 958 "osm_qos_parser_y.y"
                                                                     {
                        /* srp with target guids - this rule is similar
                           to writing 'any' ulp with target port guids */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("SRP ULP rule doesn't have port guids");
                            return 1;
                        }

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_SRP_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

                    }
#line 2507 "osm_qos_parser_y.c"
    break;

  case 116: /* $@13: %empty  */
#line 994 "osm_qos_parser_y.y"
                                                 {
                        /* ipoib w/o any pkeys (default pkey) */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] = 0x7fff;

                        /*
                         * Although we know that the default partition exists,
                         * we still need to validate it by checking that it has
                         * at least two full members. Otherwise IPoIB won't work.
                         */
                        if (__validate_pkeys(range_arr, 1, TRUE)) {
                            free(range_arr[0]);
                            free(range_arr);
                            return 1;
			}

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = 1;

                    }
#line 2534 "osm_qos_parser_y.c"
    break;

  case 118: /* $@14: %empty  */
#line 1017 "osm_qos_parser_y.y"
                                                                       {
                        /* ipoib with pkeys */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("IPoIB ULP rule doesn't have pkeys");
                            return 1;
                        }

                        /* get all the pkey ranges */
                        __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        /*
                         * Validate pkeys.
                         * For IPoIB pkeys the validation is strict.
                         * If some problem would be found, parsing will
                         * be aborted with a proper error messages.
                         */
			if (__validate_pkeys(range_arr, range_len, TRUE)) {
			    free(range_arr);
                            return 1;
			}

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = range_len;

                    }
#line 2570 "osm_qos_parser_y.c"
    break;

  case 120: /* qos_ulp_type_any_service: TK_ULP_ANY_SERVICE_ID  */
#line 1051 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2576 "osm_qos_parser_y.c"
    break;

  case 121: /* qos_ulp_type_any_pkey: TK_ULP_ANY_PKEY  */
#line 1054 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2582 "osm_qos_parser_y.c"
    break;

  case 122: /* qos_ulp_type_any_target_port_guid: TK_ULP_ANY_TARGET_PORT_GUID  */
#line 1057 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2588 "osm_qos_parser_y.c"
    break;

  case 123: /* qos_ulp_type_any_source_port_guid: TK_ULP_ANY_SOURCE_PORT_GUID  */
#line 1060 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2594 "osm_qos_parser_y.c"
    break;

  case 124: /* qos_ulp_type_any_source_target_port_guid: TK_ULP_ANY_SOURCE_TARGET_PORT_GUID  */
#line 1063 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2600 "osm_qos_parser_y.c"
    break;

  case 125: /* qos_ulp_type_sdp_default: TK_ULP_SDP_DEFAULT  */
#line 1066 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2606 "osm_qos_parser_y.c"
    break;

  case 126: /* qos_ulp_type_sdp_port: TK_ULP_SDP_PORT  */
#line 1069 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2612 "osm_qos_parser_y.c"
    break;

  case 127: /* qos_ulp_type_rds_default: TK_ULP_RDS_DEFAULT  */
#line 1072 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2618 "osm_qos_parser_y.c"
    break;

  case 128: /* qos_ulp_type_rds_port: TK_ULP_RDS_PORT  */
#line 1075 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2624 "osm_qos_parser_y.c"
    break;

  case 129: /* qos_ulp_type_iser_default: TK_ULP_ISER_DEFAULT  */
#line 1078 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2630 "osm_qos_parser_y.c"
    break;

  case 130: /* qos_ulp_type_iser_port: TK_ULP_ISER_PORT  */
#line 1081 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2636 "osm_qos_parser_y.c"
    break;

  case 131: /* qos_ulp_type_srp_guid: TK_ULP_SRP_GUID  */
#line 1084 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2642 "osm_qos_parser_y.c"
    break;

  case 132: /* qos_ulp_type_ipoib_default: TK_ULP_IPOIB_DEFAULT  */
#line 1087 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2648 "osm_qos_parser_y.c"
    break;

  case 133: /* qos_ulp_type_ipoib_pkey: TK_ULP_IPOIB_PKEY  */
#line 1090 "osm_qos_parser_y.y"
                    { __parser_ulp_match_rule_start(); }
#line 2654 "osm_qos_parser_y.c"
    break;

  case 134: /* qos_ulp_sl: single_number  */
#line 1093 "osm_qos_parser_y.y"
                            {
                        /* get the SL for ULP rules */
                        cl_list_iterator_t  list_iterator;
                        uint64_t          * p_tmp_num;
                        uint8_t             sl;

                        list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                        p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                        if (*p_tmp_num > 15)
                        {
                            yyerror("illegal SL value");
                            return 1;
                        }

                        sl = (uint8_t)(*p_tmp_num);
                        free(p_tmp_num);
                        cl_list_remove_all(&tmp_parser_struct.num_list);

                        p_current_qos_match_rule->p_qos_level =
                                 &osm_qos_policy_simple_qos_levels[sl];
                        p_current_qos_match_rule->qos_level_name =
                                 strdup(osm_qos_policy_simple_qos_levels[sl].name);

                        if (__parser_ulp_match_rule_end())
                            return 1;
                    }
#line 2685 "osm_qos_parser_y.c"
    break;

  case 135: /* port_group_name: port_group_name_start single_string  */
#line 1132 "osm_qos_parser_y.y"
                                                            {
                            /* 'name' of 'port-group' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_port_group->name)
                            {
                                yyerror("port-group has multiple 'name' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_port_group->name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2711 "osm_qos_parser_y.c"
    break;

  case 136: /* port_group_name_start: TK_NAME  */
#line 1155 "osm_qos_parser_y.y"
                                {
                            RESET_BUFFER;
                        }
#line 2719 "osm_qos_parser_y.c"
    break;

  case 137: /* port_group_use: port_group_use_start single_string  */
#line 1160 "osm_qos_parser_y.y"
                                                           {
                            /* 'use' of 'port-group' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_port_group->use)
                            {
                                yyerror("port-group has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_port_group->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2745 "osm_qos_parser_y.c"
    break;

  case 138: /* port_group_use_start: TK_USE  */
#line 1183 "osm_qos_parser_y.y"
                               {
                            RESET_BUFFER;
                        }
#line 2753 "osm_qos_parser_y.c"
    break;

  case 139: /* port_group_port_name: port_group_port_name_start string_list  */
#line 1188 "osm_qos_parser_y.y"
                                                               {
                            /* 'port-name' in 'port-group' - any num of instances */
                            cl_list_iterator_t list_iterator;
                            osm_node_t * p_node;
                            osm_physp_t * p_physp;
                            unsigned port_num;
                            char * tmp_str;
                            char * port_str;

                            /* parsing port name strings */
                            for (list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                                 list_iterator != cl_list_end(&tmp_parser_struct.str_list);
                                 list_iterator = cl_list_next(list_iterator))
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                {
                                    /* last slash in port name string is a separator
                                       between node name and port number */
                                    port_str = strrchr(tmp_str, '/');
                                    if (!port_str || (strlen(port_str) < 3) ||
                                        (port_str[1] != 'p' && port_str[1] != 'P')) {
                                        yyerror("'%s' - illegal port name",
                                                           tmp_str);
                                        free(tmp_str);
                                        cl_list_remove_all(&tmp_parser_struct.str_list);
                                        return 1;
                                    }

                                    if (!(port_num = strtoul(&port_str[2],NULL,0))) {
                                        yyerror(
                                               "'%s' - illegal port number in port name",
                                               tmp_str);
                                        free(tmp_str);
                                        cl_list_remove_all(&tmp_parser_struct.str_list);
                                        return 1;
                                    }

                                    /* separate node name from port number */
                                    port_str[0] = '\0';

                                    if (st_lookup(p_qos_policy->p_node_hash,
                                                  (st_data_t)tmp_str,
                                                  (void *)&p_node))
                                    {
                                        /* we found the node, now get the right port */
                                        p_physp = osm_node_get_physp_ptr(p_node, port_num);
                                        if (!p_physp) {
                                            yyerror(
                                                   "'%s' - port number out of range in port name",
                                                   tmp_str);
                                            free(tmp_str);
                                            cl_list_remove_all(&tmp_parser_struct.str_list);
                                            return 1;
                                        }
                                        /* we found the port, now add it to guid table */
                                        __parser_add_port_to_port_map(&p_current_port_group->port_map,
                                                                      p_physp);
                                    }
                                    free(tmp_str);
                                }
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2822 "osm_qos_parser_y.c"
    break;

  case 140: /* port_group_port_name_start: TK_PORT_NAME  */
#line 1254 "osm_qos_parser_y.y"
                                         {
                            RESET_BUFFER;
                        }
#line 2830 "osm_qos_parser_y.c"
    break;

  case 141: /* port_group_port_guid: port_group_port_guid_start list_of_ranges  */
#line 1259 "osm_qos_parser_y.y"
                                                                  {
                            /* 'port-guid' in 'port-group' - any num of instances */
                            /* list of guid ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                __parser_add_guid_range_to_port_map(
                                                      &p_current_port_group->port_map,
                                                      range_arr,
                                                      range_len);
                            }
                        }
#line 2853 "osm_qos_parser_y.c"
    break;

  case 142: /* port_group_port_guid_start: TK_PORT_GUID  */
#line 1279 "osm_qos_parser_y.y"
                                         {
                            RESET_BUFFER;
                        }
#line 2861 "osm_qos_parser_y.c"
    break;

  case 143: /* port_group_pkey: port_group_pkey_start list_of_ranges  */
#line 1284 "osm_qos_parser_y.y"
                                                             {
                            /* 'pkey' in 'port-group' - any num of instances */
                            /* list of pkey ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                __parser_add_pkey_range_to_port_map(
                                                      &p_current_port_group->port_map,
                                                      range_arr,
                                                      range_len);
                            }
                        }
#line 2884 "osm_qos_parser_y.c"
    break;

  case 144: /* port_group_pkey_start: TK_PKEY  */
#line 1304 "osm_qos_parser_y.y"
                                {
                            RESET_BUFFER;
                        }
#line 2892 "osm_qos_parser_y.c"
    break;

  case 145: /* port_group_partition: port_group_partition_start string_list  */
#line 1309 "osm_qos_parser_y.y"
                                                              {
                            /* 'partition' in 'port-group' - any num of instances */
                            __parser_add_partition_list_to_port_map(
                                               &p_current_port_group->port_map,
                                               &tmp_parser_struct.str_list);
                        }
#line 2903 "osm_qos_parser_y.c"
    break;

  case 146: /* port_group_partition_start: TK_PARTITION  */
#line 1317 "osm_qos_parser_y.y"
                                         {
                            RESET_BUFFER;
                        }
#line 2911 "osm_qos_parser_y.c"
    break;

  case 147: /* port_group_node_type: port_group_node_type_start port_group_node_type_list  */
#line 1322 "osm_qos_parser_y.y"
                                                                             {
                            /* 'node-type' in 'port-group' - any num of instances */
                        }
#line 2919 "osm_qos_parser_y.c"
    break;

  case 148: /* port_group_node_type_start: TK_NODE_TYPE  */
#line 1327 "osm_qos_parser_y.y"
                                         {
                            RESET_BUFFER;
                        }
#line 2927 "osm_qos_parser_y.c"
    break;

  case 156: /* node_type_ca: TK_NODE_TYPE_CA  */
#line 1343 "osm_qos_parser_y.y"
                                        {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_CA;
                        }
#line 2936 "osm_qos_parser_y.c"
    break;

  case 157: /* node_type_switch: TK_NODE_TYPE_SWITCH  */
#line 1349 "osm_qos_parser_y.y"
                                            {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_SWITCH;
                        }
#line 2945 "osm_qos_parser_y.c"
    break;

  case 158: /* node_type_router: TK_NODE_TYPE_ROUTER  */
#line 1355 "osm_qos_parser_y.y"
                                            {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_ROUTER;
                        }
#line 2954 "osm_qos_parser_y.c"
    break;

  case 159: /* node_type_all: TK_NODE_TYPE_ALL  */
#line 1361 "osm_qos_parser_y.y"
                                         {
                            p_current_port_group->node_types |=
                               (OSM_QOS_POLICY_NODE_TYPE_CA |
                                OSM_QOS_POLICY_NODE_TYPE_SWITCH |
                                OSM_QOS_POLICY_NODE_TYPE_ROUTER);
                        }
#line 2965 "osm_qos_parser_y.c"
    break;

  case 160: /* node_type_self: TK_NODE_TYPE_SELF  */
#line 1369 "osm_qos_parser_y.y"
                                          {
                            osm_port_t * p_osm_port =
                                osm_get_port_by_guid(p_qos_policy->p_subn,
                                     p_qos_policy->p_subn->sm_port_guid);
                            if (p_osm_port)
                                __parser_add_port_to_port_map(
                                   &p_current_port_group->port_map,
                                   p_osm_port->p_physp);
                        }
#line 2979 "osm_qos_parser_y.c"
    break;

  case 161: /* vlarb_scope_group: vlarb_scope_group_start string_list  */
#line 1391 "osm_qos_parser_y.y"
                                                            {
                            /* 'group' in 'vlarb-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_vlarb_scope->group_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2999 "osm_qos_parser_y.c"
    break;

  case 162: /* vlarb_scope_group_start: TK_GROUP  */
#line 1408 "osm_qos_parser_y.y"
                                  {
                            RESET_BUFFER;
                        }
#line 3007 "osm_qos_parser_y.c"
    break;

  case 163: /* vlarb_scope_across: vlarb_scope_across_start string_list  */
#line 1413 "osm_qos_parser_y.y"
                                                         {
                            /* 'across' in 'vlarb-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_vlarb_scope->across_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3027 "osm_qos_parser_y.c"
    break;

  case 164: /* vlarb_scope_across_start: TK_ACROSS  */
#line 1430 "osm_qos_parser_y.y"
                                    {
                            RESET_BUFFER;
                        }
#line 3035 "osm_qos_parser_y.c"
    break;

  case 165: /* vlarb_scope_vlarb_high_limit: vlarb_scope_vlarb_high_limit_start single_number  */
#line 1435 "osm_qos_parser_y.y"
                                                                                {
                            /* 'vl-high-limit' in 'vlarb-scope' - one instance of one number */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * p_tmp_num;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (p_tmp_num)
                            {
                                p_current_vlarb_scope->vl_high_limit = (uint32_t)(*p_tmp_num);
                                p_current_vlarb_scope->vl_high_limit_set = TRUE;
                                free(p_tmp_num);
                            }

                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3056 "osm_qos_parser_y.c"
    break;

  case 166: /* vlarb_scope_vlarb_high_limit_start: TK_VLARB_HIGH_LIMIT  */
#line 1453 "osm_qos_parser_y.y"
                                                        {
                            RESET_BUFFER;
                        }
#line 3064 "osm_qos_parser_y.c"
    break;

  case 167: /* vlarb_scope_vlarb_high: vlarb_scope_vlarb_high_start num_list_with_dotdot  */
#line 1458 "osm_qos_parser_y.y"
                                                                          {
                            /* 'vlarb-high' in 'vlarb-scope' - list of pairs of numbers with ':' and ',' */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                    cl_list_insert_tail(&p_current_vlarb_scope->vlarb_high_list,num_pair);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3084 "osm_qos_parser_y.c"
    break;

  case 168: /* vlarb_scope_vlarb_high_start: TK_VLARB_HIGH  */
#line 1475 "osm_qos_parser_y.y"
                                            {
                            RESET_BUFFER;
                        }
#line 3092 "osm_qos_parser_y.c"
    break;

  case 169: /* vlarb_scope_vlarb_low: vlarb_scope_vlarb_low_start num_list_with_dotdot  */
#line 1480 "osm_qos_parser_y.y"
                                                                         {
                            /* 'vlarb-low' in 'vlarb-scope' - list of pairs of numbers with ':' and ',' */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                    cl_list_insert_tail(&p_current_vlarb_scope->vlarb_low_list,num_pair);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3112 "osm_qos_parser_y.c"
    break;

  case 170: /* vlarb_scope_vlarb_low_start: TK_VLARB_LOW  */
#line 1497 "osm_qos_parser_y.y"
                                          {
                            RESET_BUFFER;
                        }
#line 3120 "osm_qos_parser_y.c"
    break;

  case 171: /* sl2vl_scope_group: sl2vl_scope_group_start string_list  */
#line 1513 "osm_qos_parser_y.y"
                                                            {
                            /* 'group' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_sl2vl_scope->group_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3140 "osm_qos_parser_y.c"
    break;

  case 172: /* sl2vl_scope_group_start: TK_GROUP  */
#line 1530 "osm_qos_parser_y.y"
                                  {
                            RESET_BUFFER;
                        }
#line 3148 "osm_qos_parser_y.c"
    break;

  case 173: /* sl2vl_scope_across: sl2vl_scope_across_start string_list  */
#line 1535 "osm_qos_parser_y.y"
                                                             {
                            /* 'across' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str) {
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_from_list,tmp_str);
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_to_list,strdup(tmp_str));
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3170 "osm_qos_parser_y.c"
    break;

  case 174: /* sl2vl_scope_across_start: TK_ACROSS  */
#line 1554 "osm_qos_parser_y.y"
                                    {
                            RESET_BUFFER;
                        }
#line 3178 "osm_qos_parser_y.c"
    break;

  case 175: /* sl2vl_scope_across_from: sl2vl_scope_across_from_start string_list  */
#line 1559 "osm_qos_parser_y.y"
                                                                    {
                            /* 'across-from' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_from_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3198 "osm_qos_parser_y.c"
    break;

  case 176: /* sl2vl_scope_across_from_start: TK_ACROSS_FROM  */
#line 1576 "osm_qos_parser_y.y"
                                              {
                            RESET_BUFFER;
                        }
#line 3206 "osm_qos_parser_y.c"
    break;

  case 177: /* sl2vl_scope_across_to: sl2vl_scope_across_to_start string_list  */
#line 1581 "osm_qos_parser_y.y"
                                                                {
                            /* 'across-to' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str) {
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_to_list,tmp_str);
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3227 "osm_qos_parser_y.c"
    break;

  case 178: /* sl2vl_scope_across_to_start: TK_ACROSS_TO  */
#line 1599 "osm_qos_parser_y.y"
                                          {
                            RESET_BUFFER;
                        }
#line 3235 "osm_qos_parser_y.c"
    break;

  case 179: /* sl2vl_scope_from: sl2vl_scope_from_start sl2vl_scope_from_list_or_asterisk  */
#line 1604 "osm_qos_parser_y.y"
                                                                                 {
                            /* 'from' in 'sl2vl-scope' - any num of instances */
                        }
#line 3243 "osm_qos_parser_y.c"
    break;

  case 180: /* sl2vl_scope_from_start: TK_FROM  */
#line 1609 "osm_qos_parser_y.y"
                                {
                            RESET_BUFFER;
                        }
#line 3251 "osm_qos_parser_y.c"
    break;

  case 181: /* sl2vl_scope_to: sl2vl_scope_to_start sl2vl_scope_to_list_or_asterisk  */
#line 1614 "osm_qos_parser_y.y"
                                                                             {
                            /* 'to' in 'sl2vl-scope' - any num of instances */
                        }
#line 3259 "osm_qos_parser_y.c"
    break;

  case 182: /* sl2vl_scope_to_start: TK_TO  */
#line 1619 "osm_qos_parser_y.y"
                              {
                            RESET_BUFFER;
                        }
#line 3267 "osm_qos_parser_y.c"
    break;

  case 185: /* sl2vl_scope_from_asterisk: TK_ASTERISK  */
#line 1628 "osm_qos_parser_y.y"
                                       {
                            int i;
                            for (i = 0; i < OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH; i++)
                                p_current_sl2vl_scope->from[i] = TRUE;
                        }
#line 3277 "osm_qos_parser_y.c"
    break;

  case 188: /* sl2vl_scope_to_asterisk: TK_ASTERISK  */
#line 1639 "osm_qos_parser_y.y"
                                     {
                            int i;
                            for (i = 0; i < OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH; i++)
                                p_current_sl2vl_scope->to[i] = TRUE;
                        }
#line 3287 "osm_qos_parser_y.c"
    break;

  case 189: /* sl2vl_scope_from_list_of_ranges: list_of_ranges  */
#line 1646 "osm_qos_parser_y.y"
                                                {
                            int i;
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;
                            uint8_t               num1, num2;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                {
                                    if ( num_pair[1] >= OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH )
                                    {
                                        yyerror("port number out of range 'from' list");
                                        free(num_pair);
                                        cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                                        return 1;
                                    }
                                    num1 = (uint8_t)num_pair[0];
                                    num2 = (uint8_t)num_pair[1];
                                    free(num_pair);
                                    for (i = num1; i <= num2; i++)
                                        p_current_sl2vl_scope->from[i] = TRUE;
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3321 "osm_qos_parser_y.c"
    break;

  case 190: /* sl2vl_scope_to_list_of_ranges: list_of_ranges  */
#line 1677 "osm_qos_parser_y.y"
                                              {
                            int i;
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;
                            uint8_t               num1, num2;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                {
                                    if ( num_pair[1] >= OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH )
                                    {
                                        yyerror("port number out of range 'to' list");
                                        free(num_pair);
                                        cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                                        return 1;
                                    }
                                    num1 = (uint8_t)num_pair[0];
                                    num2 = (uint8_t)num_pair[1];
                                    free(num_pair);
                                    for (i = num1; i <= num2; i++)
                                        p_current_sl2vl_scope->to[i] = TRUE;
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3355 "osm_qos_parser_y.c"
    break;

  case 191: /* sl2vl_scope_sl2vl_table: sl2vl_scope_sl2vl_table_start num_list  */
#line 1709 "osm_qos_parser_y.y"
                                                                 {
                            /* 'sl2vl-table' - one instance of exactly
                               OSM_QOS_POLICY_SL2VL_TABLE_LEN numbers */
                            cl_list_iterator_t    list_iterator;
                            uint64_t              num;
                            uint64_t            * p_num;
                            int                   i = 0;

                            if (p_current_sl2vl_scope->sl2vl_table_set)
                            {
                                yyerror("sl2vl-scope has more than one sl2vl-table");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            if (cl_list_count(&tmp_parser_struct.num_list) != OSM_QOS_POLICY_SL2VL_TABLE_LEN)
                            {
                                yyerror("wrong number of values in 'sl2vl-table' (should be 16)");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_list) )
                            {
                                p_num = (uint64_t*)cl_list_obj(list_iterator);
                                num = *p_num;
                                free(p_num);
                                if (num >= OSM_QOS_POLICY_MAX_VL_NUM)
                                {
                                    yyerror("wrong VL value in 'sl2vl-table' (should be 0 to 15)");
                                    cl_list_remove_all(&tmp_parser_struct.num_list);
                                    return 1;
                                }

                                p_current_sl2vl_scope->sl2vl_table[i++] = (uint8_t)num;
                                list_iterator = cl_list_next(list_iterator);
                            }
                            p_current_sl2vl_scope->sl2vl_table_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3401 "osm_qos_parser_y.c"
    break;

  case 192: /* sl2vl_scope_sl2vl_table_start: TK_SL2VL_TABLE  */
#line 1752 "osm_qos_parser_y.y"
                                              {
                            RESET_BUFFER;
                        }
#line 3409 "osm_qos_parser_y.c"
    break;

  case 193: /* qos_level_name: qos_level_name_start single_string  */
#line 1769 "osm_qos_parser_y.y"
                                                           {
                            /* 'name' of 'qos-level' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_level->name)
                            {
                                yyerror("qos-level has multiple 'name' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_level->name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3435 "osm_qos_parser_y.c"
    break;

  case 194: /* qos_level_name_start: TK_NAME  */
#line 1792 "osm_qos_parser_y.y"
                                {
                            RESET_BUFFER;
                        }
#line 3443 "osm_qos_parser_y.c"
    break;

  case 195: /* qos_level_use: qos_level_use_start single_string  */
#line 1797 "osm_qos_parser_y.y"
                                                          {
                            /* 'use' of 'qos-level' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_level->use)
                            {
                                yyerror("qos-level has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_level->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3469 "osm_qos_parser_y.c"
    break;

  case 196: /* qos_level_use_start: TK_USE  */
#line 1820 "osm_qos_parser_y.y"
                               {
                            RESET_BUFFER;
                        }
#line 3477 "osm_qos_parser_y.c"
    break;

  case 197: /* qos_level_sl: qos_level_sl_start single_number  */
#line 1825 "osm_qos_parser_y.y"
                                                         {
                            /* 'sl' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->sl_set)
                            {
                                yyerror("'qos-level' has multiple 'sl' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            p_current_qos_level->sl = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->sl_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3500 "osm_qos_parser_y.c"
    break;

  case 198: /* qos_level_sl_start: TK_SL  */
#line 1845 "osm_qos_parser_y.y"
                              {
                            RESET_BUFFER;
                        }
#line 3508 "osm_qos_parser_y.c"
    break;

  case 199: /* qos_level_mtu_limit: qos_level_mtu_limit_start single_number  */
#line 1850 "osm_qos_parser_y.y"
                                                                {
                            /* 'mtu-limit' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->mtu_limit_set)
                            {
                                yyerror("'qos-level' has multiple 'mtu-limit' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (*p_num > OSM_QOS_POLICY_MAX_MTU || *p_num < OSM_QOS_POLICY_MIN_MTU)
                            {
                                yyerror("mtu limit is out of range, value: %d", *p_num);
                                free(p_num);
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            p_current_qos_level->mtu_limit = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->mtu_limit_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3538 "osm_qos_parser_y.c"
    break;

  case 200: /* qos_level_mtu_limit_start: TK_MTU_LIMIT  */
#line 1877 "osm_qos_parser_y.y"
                                        {
                            /* 'mtu-limit' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3547 "osm_qos_parser_y.c"
    break;

  case 201: /* qos_level_rate_limit: qos_level_rate_limit_start single_number  */
#line 1883 "osm_qos_parser_y.y"
                                                                  {
                            /* 'rate-limit' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->rate_limit_set)
                            {
                                yyerror("'qos-level' has multiple 'rate-limit' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (*p_num > OSM_QOS_POLICY_MAX_RATE || *p_num < OSM_QOS_POLICY_MIN_RATE)
                            {
                                yyerror("rate limit is out of range, value: %d", *p_num);
                                free(p_num);
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            p_current_qos_level->rate_limit = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->rate_limit_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3577 "osm_qos_parser_y.c"
    break;

  case 202: /* qos_level_rate_limit_start: TK_RATE_LIMIT  */
#line 1910 "osm_qos_parser_y.y"
                                          {
                            /* 'rate-limit' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3586 "osm_qos_parser_y.c"
    break;

  case 203: /* qos_level_packet_life: qos_level_packet_life_start single_number  */
#line 1916 "osm_qos_parser_y.y"
                                                                  {
                            /* 'packet-life' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->pkt_life_set)
                            {
                                yyerror("'qos-level' has multiple 'packet-life' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            p_current_qos_level->pkt_life = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->pkt_life_set= TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3609 "osm_qos_parser_y.c"
    break;

  case 204: /* qos_level_packet_life_start: TK_PACKET_LIFE  */
#line 1936 "osm_qos_parser_y.y"
                                            {
                            /* 'packet-life' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3618 "osm_qos_parser_y.c"
    break;

  case 205: /* qos_level_path_bits: qos_level_path_bits_start list_of_ranges  */
#line 1942 "osm_qos_parser_y.y"
                                                                 {
                            /* 'path-bits' in 'qos-level' - any num of instances */
                            /* list of path bit ranges */

                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_level->path_bits_range_len )
                                {
                                    p_current_qos_level->path_bits_range_arr = range_arr;
                                    p_current_qos_level->path_bits_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_level->path_bits_range_arr,
                                                      p_current_qos_level->path_bits_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_level->path_bits_range_arr = new_range_arr;
                                    p_current_qos_level->path_bits_range_len = new_range_len;
                                }
                            }
                        }
#line 3656 "osm_qos_parser_y.c"
    break;

  case 206: /* qos_level_path_bits_start: TK_PATH_BITS  */
#line 1977 "osm_qos_parser_y.y"
                                        {
                            RESET_BUFFER;
                        }
#line 3664 "osm_qos_parser_y.c"
    break;

  case 207: /* qos_level_pkey: qos_level_pkey_start list_of_ranges  */
#line 1982 "osm_qos_parser_y.y"
                                                            {
                            /* 'pkey' in 'qos-level' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_level->pkey_range_len )
                                {
                                    p_current_qos_level->pkey_range_arr = range_arr;
                                    p_current_qos_level->pkey_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_level->pkey_range_arr,
                                                      p_current_qos_level->pkey_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_level->pkey_range_arr = new_range_arr;
                                    p_current_qos_level->pkey_range_len = new_range_len;
                                }
                            }
                        }
#line 3700 "osm_qos_parser_y.c"
    break;

  case 208: /* qos_level_pkey_start: TK_PKEY  */
#line 2015 "osm_qos_parser_y.y"
                                {
                            RESET_BUFFER;
                        }
#line 3708 "osm_qos_parser_y.c"
    break;

  case 209: /* qos_match_rule_use: qos_match_rule_use_start single_string  */
#line 2032 "osm_qos_parser_y.y"
                                                               {
                            /* 'use' of 'qos-match-rule' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_match_rule->use)
                            {
                                yyerror("'qos-match-rule' has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_match_rule->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3734 "osm_qos_parser_y.c"
    break;

  case 210: /* qos_match_rule_use_start: TK_USE  */
#line 2055 "osm_qos_parser_y.y"
                                 {
                            RESET_BUFFER;
                        }
#line 3742 "osm_qos_parser_y.c"
    break;

  case 211: /* qos_match_rule_qos_class: qos_match_rule_qos_class_start list_of_ranges  */
#line 2060 "osm_qos_parser_y.y"
                                                                        {
                            /* 'qos-class' in 'qos-match-rule' - num of instances of list of ranges */
                            /* list of class ranges (QoS Class is 12-bit value) */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->qos_class_range_len )
                                {
                                    p_current_qos_match_rule->qos_class_range_arr = range_arr;
                                    p_current_qos_match_rule->qos_class_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->qos_class_range_arr,
                                                      p_current_qos_match_rule->qos_class_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->qos_class_range_arr = new_range_arr;
                                    p_current_qos_match_rule->qos_class_range_len = new_range_len;
                                }
                            }
                        }
#line 3779 "osm_qos_parser_y.c"
    break;

  case 212: /* qos_match_rule_qos_class_start: TK_QOS_CLASS  */
#line 2094 "osm_qos_parser_y.y"
                                             {
                            RESET_BUFFER;
                        }
#line 3787 "osm_qos_parser_y.c"
    break;

  case 213: /* qos_match_rule_source: qos_match_rule_source_start string_list  */
#line 2099 "osm_qos_parser_y.y"
                                                                {
                            /* 'source' in 'qos-match-rule' - text */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_qos_match_rule->source_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3807 "osm_qos_parser_y.c"
    break;

  case 214: /* qos_match_rule_source_start: TK_SOURCE  */
#line 2116 "osm_qos_parser_y.y"
                                       {
                            RESET_BUFFER;
                        }
#line 3815 "osm_qos_parser_y.c"
    break;

  case 215: /* qos_match_rule_destination: qos_match_rule_destination_start string_list  */
#line 2121 "osm_qos_parser_y.y"
                                                                         {
                            /* 'destination' in 'qos-match-rule' - text */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_qos_match_rule->destination_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3835 "osm_qos_parser_y.c"
    break;

  case 216: /* qos_match_rule_destination_start: TK_DESTINATION  */
#line 2138 "osm_qos_parser_y.y"
                                                 {
                            RESET_BUFFER;
                        }
#line 3843 "osm_qos_parser_y.c"
    break;

  case 217: /* qos_match_rule_qos_level_name: qos_match_rule_qos_level_name_start single_string  */
#line 2143 "osm_qos_parser_y.y"
                                                                                  {
                            /* 'qos-level-name' in 'qos-match-rule' - single string */
                            cl_list_iterator_t   list_iterator;
                            char               * tmp_str;

                            if (p_current_qos_match_rule->qos_level_name)
                            {
                                yyerror("qos-match-rule has multiple 'qos-level-name' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_match_rule->qos_level_name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3869 "osm_qos_parser_y.c"
    break;

  case 218: /* qos_match_rule_qos_level_name_start: TK_QOS_LEVEL_NAME  */
#line 2166 "osm_qos_parser_y.y"
                                                       {
                            RESET_BUFFER;
                        }
#line 3877 "osm_qos_parser_y.c"
    break;

  case 219: /* qos_match_rule_service_id: qos_match_rule_service_id_start list_of_ranges  */
#line 2171 "osm_qos_parser_y.y"
                                                                          {
                            /* 'service-id' in 'qos-match-rule' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->service_id_range_len )
                                {
                                    p_current_qos_match_rule->service_id_range_arr = range_arr;
                                    p_current_qos_match_rule->service_id_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->service_id_range_arr,
                                                      p_current_qos_match_rule->service_id_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->service_id_range_arr = new_range_arr;
                                    p_current_qos_match_rule->service_id_range_len = new_range_len;
                                }
                            }
                        }
#line 3913 "osm_qos_parser_y.c"
    break;

  case 220: /* qos_match_rule_service_id_start: TK_SERVICE_ID  */
#line 2204 "osm_qos_parser_y.y"
                                               {
                            RESET_BUFFER;
                        }
#line 3921 "osm_qos_parser_y.c"
    break;

  case 221: /* qos_match_rule_pkey: qos_match_rule_pkey_start list_of_ranges  */
#line 2209 "osm_qos_parser_y.y"
                                                                 {
                            /* 'pkey' in 'qos-match-rule' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->pkey_range_len )
                                {
                                    p_current_qos_match_rule->pkey_range_arr = range_arr;
                                    p_current_qos_match_rule->pkey_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->pkey_range_arr,
                                                      p_current_qos_match_rule->pkey_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->pkey_range_arr = new_range_arr;
                                    p_current_qos_match_rule->pkey_range_len = new_range_len;
                                }
                            }
                        }
#line 3957 "osm_qos_parser_y.c"
    break;

  case 222: /* qos_match_rule_pkey_start: TK_PKEY  */
#line 2242 "osm_qos_parser_y.y"
                                   {
                            RESET_BUFFER;
                        }
#line 3965 "osm_qos_parser_y.c"
    break;

  case 223: /* single_string: single_string_elems  */
#line 2253 "osm_qos_parser_y.y"
                                        {
                        cl_list_insert_tail(&tmp_parser_struct.str_list,
                                            strdup(__parser_strip_white(tmp_parser_struct.str)));
                        tmp_parser_struct.str[0] = '\0';
                    }
#line 3975 "osm_qos_parser_y.c"
    break;

  case 226: /* single_string_element: TK_TEXT  */
#line 2264 "osm_qos_parser_y.y"
                               {
                        strcat(tmp_parser_struct.str,yyvsp[0]);
                        free(yyvsp[0]);
                    }
#line 3984 "osm_qos_parser_y.c"
    break;

  case 232: /* number: TK_NUMBER  */
#line 2284 "osm_qos_parser_y.y"
                              {
                        uint64_t * p_num = (uint64_t*)malloc(sizeof(uint64_t));
                        __parser_str2uint64(p_num,yyvsp[0]);
                        free(yyvsp[0]);
                        cl_list_insert_tail(&tmp_parser_struct.num_list, p_num);
                    }
#line 3995 "osm_qos_parser_y.c"
    break;

  case 233: /* num_list_with_dotdot: number_from_pair_1 TK_DOTDOT number_from_pair_2  */
#line 2292 "osm_qos_parser_y.y"
                                                                      {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        num_pair[0] = tmp_parser_struct.num_pair[0];
                        num_pair[1] = tmp_parser_struct.num_pair[1];
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4006 "osm_qos_parser_y.c"
    break;

  case 234: /* num_list_with_dotdot: num_list_with_dotdot TK_COMMA number_from_pair_1 TK_DOTDOT number_from_pair_2  */
#line 2298 "osm_qos_parser_y.y"
                                                                                                    {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        num_pair[0] = tmp_parser_struct.num_pair[0];
                        num_pair[1] = tmp_parser_struct.num_pair[1];
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4017 "osm_qos_parser_y.c"
    break;

  case 235: /* number_from_pair_1: TK_NUMBER  */
#line 2306 "osm_qos_parser_y.y"
                                {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[0],yyvsp[0]);
                        free(yyvsp[0]);
                    }
#line 4026 "osm_qos_parser_y.c"
    break;

  case 236: /* number_from_pair_2: TK_NUMBER  */
#line 2312 "osm_qos_parser_y.y"
                                {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[1],yyvsp[0]);
                        free(yyvsp[0]);
                    }
#line 4035 "osm_qos_parser_y.c"
    break;

  case 238: /* num_list_with_dash: single_number_from_range  */
#line 2321 "osm_qos_parser_y.y"
                                               {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        num_pair[0] = tmp_parser_struct.num_pair[0];
                        num_pair[1] = tmp_parser_struct.num_pair[1];
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4046 "osm_qos_parser_y.c"
    break;

  case 239: /* num_list_with_dash: number_from_range_1 TK_DASH number_from_range_2  */
#line 2327 "osm_qos_parser_y.y"
                                                                      {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        if (tmp_parser_struct.num_pair[0] <= tmp_parser_struct.num_pair[1]) {
                            num_pair[0] = tmp_parser_struct.num_pair[0];
                            num_pair[1] = tmp_parser_struct.num_pair[1];
                        }
                        else {
                            num_pair[1] = tmp_parser_struct.num_pair[0];
                            num_pair[0] = tmp_parser_struct.num_pair[1];
                        }
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4063 "osm_qos_parser_y.c"
    break;

  case 240: /* num_list_with_dash: num_list_with_dash TK_COMMA number_from_range_1 TK_DASH number_from_range_2  */
#line 2339 "osm_qos_parser_y.y"
                                                                                                  {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        if (tmp_parser_struct.num_pair[0] <= tmp_parser_struct.num_pair[1]) {
                            num_pair[0] = tmp_parser_struct.num_pair[0];
                            num_pair[1] = tmp_parser_struct.num_pair[1];
                        }
                        else {
                            num_pair[1] = tmp_parser_struct.num_pair[0];
                            num_pair[0] = tmp_parser_struct.num_pair[1];
                        }
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4080 "osm_qos_parser_y.c"
    break;

  case 241: /* num_list_with_dash: num_list_with_dash TK_COMMA single_number_from_range  */
#line 2351 "osm_qos_parser_y.y"
                                                                           {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        num_pair[0] = tmp_parser_struct.num_pair[0];
                        num_pair[1] = tmp_parser_struct.num_pair[1];
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4091 "osm_qos_parser_y.c"
    break;

  case 242: /* single_number_from_range: TK_NUMBER  */
#line 2359 "osm_qos_parser_y.y"
                                     {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[0],yyvsp[0]);
                        __parser_str2uint64(&tmp_parser_struct.num_pair[1],yyvsp[0]);
                        free(yyvsp[0]);
                    }
#line 4101 "osm_qos_parser_y.c"
    break;

  case 243: /* number_from_range_1: TK_NUMBER  */
#line 2366 "osm_qos_parser_y.y"
                                {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[0],yyvsp[0]);
                        free(yyvsp[0]);
                    }
#line 4110 "osm_qos_parser_y.c"
    break;

  case 244: /* number_from_range_2: TK_NUMBER  */
#line 2372 "osm_qos_parser_y.y"
                                {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[1],yyvsp[0]);
                        free(yyvsp[0]);
                    }
#line 4119 "osm_qos_parser_y.c"
    break;


#line 4123 "osm_qos_parser_y.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2378 "osm_qos_parser_y.y"


/***************************************************
 ***************************************************/

int osm_qos_parse_policy_file(IN osm_subn_t * p_subn)
{
    int res = 0;
    static boolean_t first_time = TRUE;
    p_qos_parser_osm_log = &p_subn->p_osm->log;

    OSM_LOG_ENTER(p_qos_parser_osm_log);

    osm_qos_policy_destroy(p_subn->p_qos_policy);
    p_subn->p_qos_policy = NULL;

    if (!p_subn->opt.qos_policy_file) {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC06: "
                "QoS policy file name is empty\n");
        res = 1;
        goto Exit;
    }

    yyin = fopen (p_subn->opt.qos_policy_file, "r");
    if (!yyin)
    {
        if (strcmp(p_subn->opt.qos_policy_file,OSM_DEFAULT_QOS_POLICY_FILE)) {
            OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC01: "
                    "Failed opening QoS policy file %s - %s\n",
                    p_subn->opt.qos_policy_file, strerror(errno));
            res = 1;
        }
        else
            OSM_LOG(p_qos_parser_osm_log, OSM_LOG_VERBOSE,
                    "QoS policy file not found (%s)\n",
                    p_subn->opt.qos_policy_file);

        goto Exit;
    }

    if (first_time)
    {
        first_time = FALSE;
        __setup_simple_qos_levels();
        __setup_ulp_match_rules();
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_INFO,
		"Loading QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
    }
    else
        /*
         * ULP match rules list was emptied at the end of
         * previous parsing iteration.
         * What's left is to clear simple QoS levels.
         */
        __clear_simple_qos_levels();

    column_num = 1;
    line_num = 1;

    p_subn->p_qos_policy = osm_qos_policy_create(p_subn);

    __parser_tmp_struct_init();
    p_qos_policy = p_subn->p_qos_policy;

    res = yyparse();

    __parser_tmp_struct_destroy();

    if (res != 0)
    {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC03: "
                "Failed parsing QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        osm_qos_policy_destroy(p_subn->p_qos_policy);
        p_subn->p_qos_policy = NULL;
        res = 1;
        goto Exit;
    }

    /* add generated ULP match rules to the usual match rules */
    __process_ulp_match_rules();

    if (osm_qos_policy_validate(p_subn->p_qos_policy,p_qos_parser_osm_log))
    {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC04: "
                "Error(s) in QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        fprintf(stderr, "Error(s) in QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        osm_qos_policy_destroy(p_subn->p_qos_policy);
        p_subn->p_qos_policy = NULL;
        res = 1;
        goto Exit;
    }

  Exit:
    if (yyin)
    {
        yyrestart(yyin);
        fclose(yyin);
    }
    OSM_LOG_EXIT(p_qos_parser_osm_log);
    return res;
}

/***************************************************
 ***************************************************/

int yywrap()
{
    return(1);
}

/***************************************************
 ***************************************************/

static void yyerror(const char *format, ...)
{
    char s[256];
    va_list pvar;

    OSM_LOG_ENTER(p_qos_parser_osm_log);

    va_start(pvar, format);
    vsnprintf(s, sizeof(s), format, pvar);
    va_end(pvar);

    OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC05: "
            "Syntax error (line %d:%d): %s\n",
            line_num, column_num, s);
    fprintf(stderr, "Error in QoS Policy File (line %d:%d): %s.\n",
            line_num, column_num, s);
    OSM_LOG_EXIT(p_qos_parser_osm_log);
}

/***************************************************
 ***************************************************/

static char * __parser_strip_white(char * str)
{
	char *p;

	while (isspace(*str))
		str++;
	if (!*str)
		return str;
	p = str + strlen(str) - 1;
	while (isspace(*p))
		*p-- = '\0';

	return str;
}

/***************************************************
 ***************************************************/

static void __parser_str2uint64(uint64_t * p_val, char * str)
{
   *p_val = strtoull(str, NULL, 0);
}

/***************************************************
 ***************************************************/

static void __parser_port_group_start()
{
    p_current_port_group = osm_qos_policy_port_group_create();
}

/***************************************************
 ***************************************************/

static int __parser_port_group_end()
{
    if(!p_current_port_group->name)
    {
        yyerror("port-group validation failed - no port group name specified");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->port_groups,
                        p_current_port_group);
    p_current_port_group = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_vlarb_scope_start()
{
    p_current_vlarb_scope = osm_qos_policy_vlarb_scope_create();
}

/***************************************************
 ***************************************************/

static int __parser_vlarb_scope_end()
{
    if ( !cl_list_count(&p_current_vlarb_scope->group_list) &&
         !cl_list_count(&p_current_vlarb_scope->across_list) )
    {
        yyerror("vlarb-scope validation failed - no port groups specified by 'group' or by 'across'");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->vlarb_tables,
                        p_current_vlarb_scope);
    p_current_vlarb_scope = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_sl2vl_scope_start()
{
    p_current_sl2vl_scope = osm_qos_policy_sl2vl_scope_create();
}

/***************************************************
 ***************************************************/

static int __parser_sl2vl_scope_end()
{
    if (!p_current_sl2vl_scope->sl2vl_table_set)
    {
        yyerror("sl2vl-scope validation failed - no sl2vl table specified");
        return -1;
    }
    if ( !cl_list_count(&p_current_sl2vl_scope->group_list) &&
         !cl_list_count(&p_current_sl2vl_scope->across_to_list) &&
         !cl_list_count(&p_current_sl2vl_scope->across_from_list) )
    {
        yyerror("sl2vl-scope validation failed - no port groups specified by 'group', 'across-to' or 'across-from'");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->sl2vl_tables,
                        p_current_sl2vl_scope);
    p_current_sl2vl_scope = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_qos_level_start()
{
    p_current_qos_level = osm_qos_policy_qos_level_create();
}

/***************************************************
 ***************************************************/

static int __parser_qos_level_end()
{
    if (!p_current_qos_level->sl_set)
    {
        yyerror("qos-level validation failed - no 'sl' specified");
        return -1;
    }
    if (!p_current_qos_level->name)
    {
        yyerror("qos-level validation failed - no 'name' specified");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->qos_levels,
                        p_current_qos_level);
    p_current_qos_level = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_match_rule_start()
{
    p_current_qos_match_rule = osm_qos_policy_match_rule_create();
}

/***************************************************
 ***************************************************/

static int __parser_match_rule_end()
{
    if (!p_current_qos_match_rule->qos_level_name)
    {
        yyerror("match-rule validation failed - no 'qos-level-name' specified");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->qos_match_rules,
                        p_current_qos_match_rule);
    p_current_qos_match_rule = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_ulp_match_rule_start()
{
    p_current_qos_match_rule = osm_qos_policy_match_rule_create();
}

/***************************************************
 ***************************************************/

static int __parser_ulp_match_rule_end()
{
    CL_ASSERT(p_current_qos_match_rule->p_qos_level);
    cl_list_insert_tail(&__ulp_match_rules,
                        p_current_qos_match_rule);
    p_current_qos_match_rule = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_tmp_struct_init()
{
    tmp_parser_struct.str[0] = '\0';
    cl_list_construct(&tmp_parser_struct.str_list);
    cl_list_init(&tmp_parser_struct.str_list, 10);
    cl_list_construct(&tmp_parser_struct.num_list);
    cl_list_init(&tmp_parser_struct.num_list, 10);
    cl_list_construct(&tmp_parser_struct.num_pair_list);
    cl_list_init(&tmp_parser_struct.num_pair_list, 10);
}

/***************************************************
 ***************************************************/

/*
 * Do NOT free objects from the temp struct.
 * Either they are inserted into the parse tree data
 * structure, or they are already freed when copying
 * their values to the parse tree data structure.
 */
static void __parser_tmp_struct_reset()
{
    tmp_parser_struct.str[0] = '\0';
    cl_list_remove_all(&tmp_parser_struct.str_list);
    cl_list_remove_all(&tmp_parser_struct.num_list);
    cl_list_remove_all(&tmp_parser_struct.num_pair_list);
}

/***************************************************
 ***************************************************/

static void __parser_tmp_struct_destroy()
{
    __parser_tmp_struct_reset();
    cl_list_destroy(&tmp_parser_struct.str_list);
    cl_list_destroy(&tmp_parser_struct.num_list);
    cl_list_destroy(&tmp_parser_struct.num_pair_list);
}

/***************************************************
 ***************************************************/

#define __SIMPLE_QOS_LEVEL_NAME "SimpleQoSLevel_SL"
#define __SIMPLE_QOS_LEVEL_DEFAULT_NAME "SimpleQoSLevel_DEFAULT"

static void __setup_simple_qos_levels()
{
    uint8_t i;
    char tmp_buf[30];
    memset(osm_qos_policy_simple_qos_levels, 0,
           sizeof(osm_qos_policy_simple_qos_levels));
    for (i = 0; i < 16; i++)
    {
        osm_qos_policy_simple_qos_levels[i].sl = i;
        osm_qos_policy_simple_qos_levels[i].sl_set = TRUE;
        sprintf(tmp_buf, "%s%u", __SIMPLE_QOS_LEVEL_NAME, i);
        osm_qos_policy_simple_qos_levels[i].name = strdup(tmp_buf);
    }

    memset(&__default_simple_qos_level, 0,
           sizeof(__default_simple_qos_level));
    __default_simple_qos_level.name =
           strdup(__SIMPLE_QOS_LEVEL_DEFAULT_NAME);
}

/***************************************************
 ***************************************************/

static void __clear_simple_qos_levels()
{
    /*
     * Simple QoS levels are static.
     * What's left is to invalidate default simple QoS level.
     */
    __default_simple_qos_level.sl_set = FALSE;
}

/***************************************************
 ***************************************************/

static void __setup_ulp_match_rules()
{
    cl_list_construct(&__ulp_match_rules);
    cl_list_init(&__ulp_match_rules, 10);
}

/***************************************************
 ***************************************************/

static void __process_ulp_match_rules()
{
    cl_list_iterator_t list_iterator;
    osm_qos_match_rule_t *p_qos_match_rule = NULL;

    list_iterator = cl_list_head(&__ulp_match_rules);
    while (list_iterator != cl_list_end(&__ulp_match_rules))
    {
        p_qos_match_rule = (osm_qos_match_rule_t *) cl_list_obj(list_iterator);
        if (p_qos_match_rule)
            cl_list_insert_tail(&p_qos_policy->qos_match_rules,
                                p_qos_match_rule);
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(&__ulp_match_rules);
}

/***************************************************
 ***************************************************/

static int __cmp_num_range(const void * p1, const void * p2)
{
    uint64_t * pair1 = *((uint64_t **)p1);
    uint64_t * pair2 = *((uint64_t **)p2);

    if (pair1[0] < pair2[0])
        return -1;
    if (pair1[0] > pair2[0])
        return 1;

    if (pair1[1] < pair2[1])
        return -1;
    if (pair1[1] > pair2[1])
        return 1;

    return 0;
}

/***************************************************
 ***************************************************/

static void __sort_reduce_rangearr(
    uint64_t  **   arr,
    unsigned       arr_len,
    uint64_t  ** * p_res_arr,
    unsigned     * p_res_arr_len )
{
    unsigned i = 0;
    unsigned j = 0;
    unsigned last_valid_ind = 0;
    unsigned valid_cnt = 0;
    uint64_t ** res_arr;
    boolean_t * is_valid_arr;

    *p_res_arr = NULL;
    *p_res_arr_len = 0;

    qsort(arr, arr_len, sizeof(uint64_t*), __cmp_num_range);

    is_valid_arr = (boolean_t *)malloc(arr_len * sizeof(boolean_t));
    is_valid_arr[last_valid_ind] = TRUE;
    valid_cnt++;
    for (i = 1; i < arr_len; i++)
    {
        if (arr[i][0] <= arr[last_valid_ind][1])
        {
            if (arr[i][1] > arr[last_valid_ind][1])
                arr[last_valid_ind][1] = arr[i][1];
            free(arr[i]);
            arr[i] = NULL;
            is_valid_arr[i] = FALSE;
        }
        else if ((arr[i][0] - 1) == arr[last_valid_ind][1])
        {
            arr[last_valid_ind][1] = arr[i][1];
            free(arr[i]);
            arr[i] = NULL;
            is_valid_arr[i] = FALSE;
        }
        else
        {
            is_valid_arr[i] = TRUE;
            last_valid_ind = i;
            valid_cnt++;
        }
    }

    res_arr = (uint64_t **)malloc(valid_cnt * sizeof(uint64_t *));
    for (i = 0; i < arr_len; i++)
    {
        if (is_valid_arr[i])
            res_arr[j++] = arr[i];
    }
    free(is_valid_arr);
    free(arr);

    *p_res_arr = res_arr;
    *p_res_arr_len = valid_cnt;
}

/***************************************************
 ***************************************************/

static void __pkey_rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len)
{
    uint64_t   tmp_pkey;
    uint64_t * p_pkeys;
    cl_list_iterator_t list_iterator;

    list_iterator= cl_list_head(p_list);
    while( list_iterator != cl_list_end(p_list) )
    {
       p_pkeys = (uint64_t *)cl_list_obj(list_iterator);
       p_pkeys[0] &= 0x7fff;
       p_pkeys[1] &= 0x7fff;
       if (p_pkeys[0] > p_pkeys[1])
       {
           tmp_pkey = p_pkeys[1];
           p_pkeys[1] = p_pkeys[0];
           p_pkeys[0] = tmp_pkey;
       }
       list_iterator = cl_list_next(list_iterator);
    }

    __rangelist2rangearr(p_list, p_arr, p_arr_len);
}

/***************************************************
 ***************************************************/

static void __rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len)
{
    cl_list_iterator_t list_iterator;
    unsigned len = cl_list_count(p_list);
    unsigned i = 0;
    uint64_t ** tmp_arr;
    uint64_t ** res_arr = NULL;
    unsigned res_arr_len = 0;

    tmp_arr = (uint64_t **)malloc(len * sizeof(uint64_t *));

    list_iterator = cl_list_head(p_list);
    while( list_iterator != cl_list_end(p_list) )
    {
       tmp_arr[i++] = (uint64_t *)cl_list_obj(list_iterator);
       list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);

    __sort_reduce_rangearr( tmp_arr,
                            len,
                            &res_arr,
                            &res_arr_len );
    *p_arr = res_arr;
    *p_arr_len = res_arr_len;
}

/***************************************************
 ***************************************************/

static void __merge_rangearr(
    uint64_t  **   range_arr_1,
    unsigned       range_len_1,
    uint64_t  **   range_arr_2,
    unsigned       range_len_2,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len )
{
    unsigned i = 0;
    unsigned j = 0;
    unsigned len = range_len_1 + range_len_2;
    uint64_t ** tmp_arr;
    uint64_t ** res_arr = NULL;
    unsigned res_arr_len = 0;

    *p_arr = NULL;
    *p_arr_len = 0;

    tmp_arr = (uint64_t **)malloc(len * sizeof(uint64_t *));

    for (i = 0; i < range_len_1; i++)
       tmp_arr[j++] = range_arr_1[i];
    for (i = 0; i < range_len_2; i++)
       tmp_arr[j++] = range_arr_2[i];
    free(range_arr_1);
    free(range_arr_2);

    __sort_reduce_rangearr( tmp_arr,
                            len,
                            &res_arr,
                            &res_arr_len );
    *p_arr = res_arr;
    *p_arr_len = res_arr_len;
}

/***************************************************
 ***************************************************/

static void __parser_add_port_to_port_map(
    cl_qmap_t   * p_map,
    osm_physp_t * p_physp)
{
    if (cl_qmap_get(p_map, cl_ntoh64(osm_physp_get_port_guid(p_physp))) ==
        cl_qmap_end(p_map))
    {
        osm_qos_port_t * p_port = osm_qos_policy_port_create(p_physp);
        if (p_port)
            cl_qmap_insert(p_map,
                           cl_ntoh64(osm_physp_get_port_guid(p_physp)),
                           &p_port->map_item);
    }
}

/***************************************************
 ***************************************************/

static void __parser_add_guid_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len)
{
    unsigned i;
    uint64_t guid_ho;
    osm_port_t * p_osm_port;

    if (!range_arr || !range_len)
        return;

    for (i = 0; i < range_len; i++) {
         for (guid_ho = range_arr[i][0]; guid_ho <= range_arr[i][1]; guid_ho++) {
             p_osm_port =
                osm_get_port_by_guid(p_qos_policy->p_subn, cl_hton64(guid_ho));
             if (p_osm_port)
                 __parser_add_port_to_port_map(p_map, p_osm_port->p_physp);
         }
         free(range_arr[i]);
    }
    free(range_arr);
}

/***************************************************
 ***************************************************/

static void __parser_add_pkey_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len)
{
    unsigned i;
    uint64_t pkey_64;
    ib_net16_t pkey;
    osm_prtn_t * p_prtn;

    if (!range_arr || !range_len)
        return;

    for (i = 0; i < range_len; i++) {
         for (pkey_64 = range_arr[i][0]; pkey_64 <= range_arr[i][1]; pkey_64++) {
             pkey = cl_hton16((uint16_t)(pkey_64 & 0x7fff));
             p_prtn = (osm_prtn_t *)
                 cl_qmap_get(&p_qos_policy->p_subn->prtn_pkey_tbl, pkey);
             if (p_prtn != (osm_prtn_t *)cl_qmap_end(
                   &p_qos_policy->p_subn->prtn_pkey_tbl)) {
                 __parser_add_map_to_port_map(p_map, &p_prtn->part_guid_tbl);
                 __parser_add_map_to_port_map(p_map, &p_prtn->full_guid_tbl);
             }
         }
         free(range_arr[i]);
    }
    free(range_arr);
}

/***************************************************
 ***************************************************/

static void __parser_add_partition_list_to_port_map(
    cl_qmap_t  * p_map,
    cl_list_t  * p_list)
{
    cl_list_iterator_t    list_iterator;
    char                * tmp_str;
    osm_prtn_t          * p_prtn;

    /* extract all the ports from the partition
       to the port map of this port group */
    list_iterator = cl_list_head(p_list);
    while(list_iterator != cl_list_end(p_list)) {
        tmp_str = (char*)cl_list_obj(list_iterator);
        if (tmp_str) {
            p_prtn = osm_prtn_find_by_name(p_qos_policy->p_subn, tmp_str);
            if (p_prtn) {
                __parser_add_map_to_port_map(p_map, &p_prtn->part_guid_tbl);
                __parser_add_map_to_port_map(p_map, &p_prtn->full_guid_tbl);
            }
            free(tmp_str);
        }
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);
}

/***************************************************
 ***************************************************/

static void __parser_add_map_to_port_map(
    cl_qmap_t * p_dmap,
    cl_map_t  * p_smap)
{
    cl_map_iterator_t map_iterator;
    osm_physp_t * p_physp;

    if (!p_dmap || !p_smap)
        return;

    map_iterator = cl_map_head(p_smap);
    while (map_iterator != cl_map_end(p_smap)) {
        p_physp = (osm_physp_t*)cl_map_obj(map_iterator);
        __parser_add_port_to_port_map(p_dmap, p_physp);
        map_iterator = cl_map_next(map_iterator);
    }
}

/***************************************************
 ***************************************************/

static int __validate_pkeys( uint64_t ** range_arr,
                             unsigned    range_len,
                             boolean_t   is_ipoib)
{
    unsigned i;
    uint64_t pkey_64;
    ib_net16_t pkey;
    osm_prtn_t * p_prtn;

    if (!range_arr || !range_len)
        return 0;

    for (i = 0; i < range_len; i++) {
        for (pkey_64 = range_arr[i][0]; pkey_64 <= range_arr[i][1]; pkey_64++) {
            pkey = cl_hton16((uint16_t)(pkey_64 & 0x7fff));
            p_prtn = (osm_prtn_t *)
                cl_qmap_get(&p_qos_policy->p_subn->prtn_pkey_tbl, pkey);

            if (p_prtn == (osm_prtn_t *)cl_qmap_end(
                  &p_qos_policy->p_subn->prtn_pkey_tbl))
                p_prtn = NULL;

            if (is_ipoib) {
                /*
                 * Be very strict for IPoIB partition:
                 *  - the partition for the pkey have to exist
                 *  - it has to have at least 2 full members
                 */
                if (!p_prtn) {
                    yyerror("IPoIB partition, pkey 0x%04X - "
                                       "partition doesn't exist",
                                       cl_ntoh16(pkey));
                    return 1;
                }
                else if (cl_map_count(&p_prtn->full_guid_tbl) < 2) {
                    yyerror("IPoIB partition, pkey 0x%04X - "
                                       "partition has less than two full members",
                                       cl_ntoh16(pkey));
                    return 1;
                }
            }
            else if (!p_prtn) {
                /*
                 * For non-IPoIB pkey we just want to check that
                 * the relevant partition exists.
                 * And even if it doesn't, don't exit - just print
                 * error message and continue.
                 */
                 OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC02: "
			 "pkey 0x%04X - partition doesn't exist",
                         cl_ntoh16(pkey));
            }
        }
    }
    return 0;
}

/***************************************************
 ***************************************************/
